c*******************************************************************************
      Program Scanning60CoWaveforms_UniversalOption
c											  
c     Algorithm version from August 11, 2005
c                                       
c*******************************************************************************
c
c     This code serves for extracting 60Co timing response function from the 
c     DC-211 data accumulated from a setup formed by a pair of PMTs with BaF2
c     scintilation crystals	

c     THE MAIN REASON: Exploring gamma-detection timing properties of 
c                      scintillation detectors for the needs of positron 
c                      lifetime spectroscopy 
c
      real*8        Q11(3,128),Q21(3,128),Q12(3,128),Q22(3,128),
     *              xextr1,xextr2,
     *              y1(128),y2(128),yy1(128),yy2(128),yextr1,yextr2,
     *              secd,val1,val2,val1a,val2a,xroot1,xroot2,
	*              Q41(3,128),Q42(3,128),Pos,FW,SigFW,yMd1(128),
     *              yMd2(128),valMd(2),xrootMd(2),firstdMd1,parMd01,
	*              firstdMd2,parMd02,
     *              xroot1a,xroot2a,par01,par02,par01a,par02a,firstd1,
     *              firstd2,firstd1a,firstd2a,logder1,logder2,
     *              logderlim1,logderlim2,Slope(2)
	real*8        Qmea1(2),Qmea2,Qvar1(2),Qvar2,Qcov(2),QA(2,2),
     *              QAinv(2,2),Qll,Qul,Qslope(2),SlopeQQ(2)
	real*4        CF1,CF2,WiL1,WiU1,WiL2,WiU2,var1,var2,varlim1,
     *              varlim2,amean(2),CFi(2),ChInt(2,-20:160),
     *              xrootInt(2),QtyX(2),CFiU(2),WidthQty(2),ValMdU(2),
	*              Qty(2),asymm(2),diff,Qlist(5000000),WiIntL(2),
	*              WiIntU(2),SlopeX
	integer*1     Ch(2,564),min1,min2
	integer       iw1(2),iw2(2),iw3(2),iw4(2),ierr1,ierr2,ierr1a,
     *              ierr2a,kbest1,
     *              kbest2,ksh2(2),ksh3(2),IntLL(2),IntUL(2),kint(2),
     *              ierrMd1,ierrMd2,nref(2),ierrRes,ifailInv2
	integer*4     iwvfm,nwvfm,isegm,nsegm,khi,ihi(5120),ihiInt(5120),
     *              ihiLogDer(2,1000),mon,mon1,mon1a,mon2,mon3,mon4,
     *              mon5,mon5a,mon5b,mon6,
     *              mon7,nitems,iitems,kkhi,iev,nev
	integer*4     AdHocHi(-20000:-10000),ihiarea(2,3000),naux 
      integer*4     nQitems,moniwrong,IhiIntSgnl(2,10000) 
      dimension     PulseHT(2)
	character*5   scan
	character*6   string
	character*60  filename
	character*101 filename1,filename2
	character*90  path1,path2
	character*76  path,pathr
	character*6   stringr
	character*80  description
c
      data          ihi           /   5120*0/,    ihiInt   /5120*0/,
     *              ihiLogDer     /   2000*0/,    AdHocHi /10001*0/,
     *              Qlist         /5000000*0./,  ihiarea   /6000*0/,
     *              IhiIntSgnl  /  20000*0/
c
	description='Stop:Hamamatsu#2, Start:Photek MCP PMT-325' 
      nsamp=300				
	nsegm=200
	nwvfm=20000
      nitems=2000
	cor1=0.037
      cor2=0.165
c
	iw1(1)=0 
	iw1(2)=0      
	iw2(1)=0 
   	iw2(2)=0  
	iw3(1)=40   
	iw3(2)=40  
	iw4(1)=4   
	iw4(2)=4   
	ksh2(1)=0
	ksh2(2)=0   
	ksh3(1)=52
	ksh3(2)=52 
	asymm(1)=0.00
	asymm(2)=0.00
	StpStrSpac=52.0     !Stoptime-Starttime spacing in units of 0.25 ns  
c	
c     Limits for integration
c
	IntLL(1)=-8	      
	IntLL(2)=-8  
	IntUL(1)=12	      
	IntUL(2)=12    
	SlopeX1=0.0
	SlopeX2=0.0
	Qll=-100000.d0	  ! (in ps)	                               
	Qul=+100000.d0	                                           
c  
      write (*,*) 'Scan No. (Integer 0-999):'
	read  (*,*) iscan
	write (scan,100) iscan
  100 format (i5.5)
CC    write (*,*) 'Path plus filename without dot and numerical suffix:'
CC	read  (*,*) path
      path='F:\Hama2PMT325_60Co\AcqirisRun'
c        
	write (*,*) 'The number segments for display (<301):'
	read  (*,*) nsegmd
c                 nsegmd=10
C$	write (*,*) 'CF-fractios (R*4):'
C$	read  (*,*) CF1, CF2
c                 cf1=0.45
c	            cf2=0.45
c	write (*,*) 'CF-fractios for integrated signals (R*4):'
c	read  (*,*) CFi(1), CFi(2)
                  cfi(1)=0.06
	            cfi(2)=0.02
c	write (*,*) 'Upper CF-fractios for integrated signals (R*4):'
c	read  (*,*) CFiU(1), CFiU(2)
	            cfiu(1)=0.85
	            cfiu(2)=0.85
c	write (*,*) 'PH window for STOP signal (Real):'
c	read  (*,*) WiL1,WiU1
                  wil1=155.
	            wiu1=255.
c     write (*,*) '         ... START signal (Real):'
c	read  (*,*) WiL2,WiU2 
                  wil2=187.
	            wiu2=255.
c	write (*,*) 'Integrated-signal window for STOP signal (Real):'
c	read  (*,*) WiIntL(1),WiIntU(1)
                  WiIntL(1)=0.
	            WiIntU(1)=9999.
c     write (*,*) '                         ... START signal (Real):'
c	read  (*,*) WiIntL(2),WiIntU(2) 
                  WiIntL(2)=0.
	            WiIntU(2)=9999.
c	write (*,*) 'START and STOP base-line rms limts (Real):'   
c	read  (*,*) varlim1, varlim2							   			  
                  varlim1=2.0
	            varlim2=2.0
	varlim1=varlim1**2
	varlim2=varlim2**2
C$	write (*,*) 'START and STOP log. der. lower limits (1/ns, Real):'   
C$	read  (*,*) rlogderlim1,rlogderlim2
c                  rlogderlim1=1.58
c                  rlogderlim2=1.62
C$	logderlim1=dble(rlogderlim1/4.)
C$	logderlim2=dble(rlogderlim2/4.)
c	
	call ProduceMatrix_3xN(iw4(1),Q41,ifail)
	if (ifail.ne.0) then
	   write (*,*) 'Problems with Q41-matrix inversion ...'
	   stop
	endif
c	
	call ProduceMatrix_3xN(iw4(2),Q42,ifail)
	if (ifail.ne.0) then
	   write (*,*) 'Problems with Q42-matrix inversion ...'
	   stop
	endif
c
      mon=0
      mon1=0
	mon1a=0
      mon2=0
      mon3=0
      mon4=0
      mon5=0
	mon5a=0
	mon5b=0
      mon6=0
	mon7=0
	moniwrong=0
	nev=1
	isegmd=0
	iitems=0
	Qlist(1)=1.e10
c
      nQitems=0
      Qmea1(1)=0.d0
      Qmea1(2)=0.d0
      Qmea2=0.d0
      Qvar1(1)=0.d0
      Qvar1(2)=0.d0
      Qvar2=0.d0
      Qcov(1)=0.d0
      Qcov(2)=0.d0	
c
      open (unit=5,file='AuxPoints'//scan//'.dat',status='new')
      open 
     *(unit=61,file='iTimCFdiffVsWidthDiff'//scan//'.dat',status='new')
c    *(unit=61,file='iTimCFdiffVsWidthNo1'//scan//'.dat',status='new')
      open 
     *(unit=6,file='iTimCFdiff_vs_Sign2Area'//scan//'.dat',status='new')
      open 
     *(unit=7,file=
     *'iTimCFdiff_vs_modulo500-iTimCFsum'//scan//'.dat',status='new')
      open 
     *(unit=8,file='CFtime1VsCFtime2_'//scan//'.dat',status='new')
	open (unit=3,file='AreaNormSegmnts'//scan//'.dat',status='new')
	open (unit=13,file='IntSegmnts1_Scan'//scan//'.dat',status='new')
	open (unit=23,file='IntSegmnts2_Scan'//scan//'.dat',status='new')
	open (unit=33,file='SpectOfIntegratdSignals'//scan//'.dat',
     *     status='new')
c
     	pathr=adjustr(path)
      path1=pathr//'\DC211 x2 Ch1_'
      path2=pathr//'\DC211 x2 Ch2_'
c 
      do  iwvfm=1,nwvfm
          write (string,111) iwvfm
  111     format(i6)
          string=adjustl(string)	
	    filename1=trim(path1//string)//'.data'
	    filename2=trim(path2//string)//'.data'
	    open (unit=1,err=22,file=filename1,form='binary',status='old')
	    open (unit=2,err=22,file=filename2,form='binary',status='old')
	    if ((iwvfm/50)*50.eq.iwvfm) 
     *    write (*,*) ' iwvfm:',iwvfm
	    do isegm=1,nsegm
		   read (1,err=222) (Ch(1,k),k=1,nsamp)
		   read (2,err=222) (Ch(2,k),k=1,nsamp)
             min1=127
             do k=1,nsamp
	          if (Ch(1,k).lt.min1) then
	    	     min1=Ch(1,k)
	             kmin1=k
	          endif
	       enddo !k			  
	       if (min1.eq.-128) goto 10              ! out of PH-range
	       if ((kmin1+IntUL(1)).ge.nsamp) goto 10 ! out of t-range
             if ((kmin1-ksh3(1)).le.1) goto 10	  ! out of t-range
             min2=127
             do k=1,nsamp
	          if (Ch(2,k).lt.min2) then
				 min2=Ch(2,k)
	             kmin2=k
	          endif
	       enddo !k
	       if (min2.eq.-128) goto 10               ! out of PH-range
	       if ((kmin2+IntUL(2)).ge.nsamp) goto 10  ! out of t-range
             if ((kmin2-ksh3(2)).le.1) goto 10	   ! out of t-range	       
	       kbest1=kmin1
		   kbest2=kmin2
c    
             var1=0.0
	       amean(1)=0.0
		   do k=kbest1-ksh3(1),kbest1-ksh3(1)+iw3(1)-1
	          amean(1)=amean(1)+float(Ch(1,k))
	          var1=var1+float(Ch(1,k))**2
		   enddo !k 
	       amean(1)=amean(1)/float(iw3(1))
	       var1=var1/float(iw3(1))-amean(1)**2
	       if (var1.gt.varlim1) goto 30            ! noisy baseline
c			  
             var2=0.0
		   amean(2)=0.0
		   do k=kbest2-ksh3(2),kbest2-ksh3(2)+iw3(2)-1
	          amean(2)=amean(2)+float(Ch(2,k))
	          var2=var2+float(Ch(2,k))**2
		   enddo !k 
	       amean(2)=amean(2)/float(iw3(2))
	       var2=var2/float(iw3(2))-amean(2)**2
	       if (var2.gt.varlim2) goto 30            ! noisy baseline
c			  
c		   Events with noisy baselines now excluded 
c
	       PulseHT(1)=-float(min1)+amean(1)
	       PulseHT(2)=-float(min2)+amean(2) 
	       if (PulseHT(1).gt.WiU1) goto 40 ! out of PH window
	       if (PulseHT(1).lt.WiL1) goto 40 ! out of PH window
	       if (PulseHT(2).gt.WiU2) goto 40 ! out of PH window
	       if (PulseHT(2).lt.WiL2) goto 40 ! out of PH window
c
c            ... and also the events with too low or too high PH's
c
c		   Getting integrated signals:
c    
            do kk=1,2
                do k=-20,160
	             ChInt(kk,k)=0.
	          enddo ! k
	       enddo !kk
             kint(1)=kbest1
		   kint(2)=kbest2
		   do kk=1,2		   
		      do k=IntLL(kk),IntUL(kk)
	             ChInt(kk,k)=ChInt(kk,k-1)-float(Ch(kk,kint(kk)+k))+
     +             amean(kk) 
	          enddo !k
		   enddo !kk
c
c            Incrementing histograms for integrated signals:
c
	       do kk=1,2
	          kkk=int(ChInt(kk,IntUL(kk)))+1
	          if (kkk.gt.0.and.kkk.le.10000) 
     *          IhiIntSgnl(kk,kkk)=IhiIntSgnl(kk,kkk)+1
	       enddo !kk
cc
cc    if (iwvfm.ge.6892.and.isess.eq.2) then
cc	write (*,*) 'iwvfm,isegm:',iwvfm,isegm
cc	endif        
cc
c
c            Discrimination imposed by windows for integrated signals
c
	       do kk=1,2
	          if (ChInt(kk,IntUL(kk)).lt.WiIntL(kk)) goto 40
	          if (ChInt(kk,IntUL(kk)).gt.WiIntU(kk)) goto 40
	       enddo !kk
c		   write (*,*) ChInt(1,IntUL(1)),ChInt(2,IntUL(2))          

c
c		   Finding the CF points of the integrated signals:		   	  		       		   
c
	       goto 7175
C$$$$$$$$$$$$$$$$$$$$$$  This skipped fragment is erroneous  $$$$$$$$$$$$$$$$$$
	       do kk=1,2
		      valMd(kk)=dble(ChInt(kk,IntUL(kk))*CFi(kk))
	          do k=IntLL(kk),IntUL(kk)
	             if (dble(ChInt(kk,k)).ge.valMd(kk)) then
				    if (kk.eq.2) then
	                   nref(2)=k-1-iw4(2)/2
	                   if (nref(2).le.IntLL(2)) then
					      goto 10                           ! out of t-range
	                   endif
					   if ((nref(2)+iw4(2)).ge.IntUL(2)) then
                            goto 10                           ! out of t-range
                         endif
					   do kkk=1,iw4(2)
	                      yMd2(kkk)=dble(ChInt(2,nref(2)+kkk))
	                   enddo !kkk
	                   else 
		               xrootMd(1)=(valMd(1)-ChInt(1,k-1))/
     /                   (ChInt(1,k)-ChInt(1,k-1))+1.0 
	                   xii=float(k-1)+xrootMd(1)-1.0
	                   nref(1)=nint(xii-float(iw4(1))/2.-0.5+asymm(1))
	                   if (nref(1).le.IntLL(1)) then 
					      goto 10                            ! out of t-range
	                   endif
	                   if ((nref(1)+iw4(1)).ge.IntUL(1)) then
                            goto 10						   	 ! out of t-range
	                   endif
	                   if (iw4(1).ge.3) then
	                      do kkk=1,iw4(1)
	                         yMd1(kkk)=dble(ChInt(1,nref(1)+kkk))
	                      enddo !kkk
	                   endif
	                endif 
	                goto 7301 
	             endif
	          enddo !k
 7301	          continue
	          goto 50	                        ! failure to find a iCF-pt
	       enddo !kk
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
 7175		   continue
c=============================   This section is probably correct  ===============
	       do kk=1,2
		      valMd(kk)=dble(ChInt(kk,IntUL(kk))*CFi(kk))
c	write (*,*) 'kk,valMd(kk):',kk,valMd(kk)
	          do k=IntLL(kk),IntUL(kk)
c	write (*,*) 'k,ChInt(kk,k):',k,ChInt(kk,k)
	             if (dble(ChInt(kk,k)).ge.valMd(kk)) then
		            xrootMd(kk)=(valMd(kk)-ChInt(kk,k-1))/
     /                (ChInt(kk,k)-ChInt(kk,k-1))+1.0 
	                xii=float(k-1)+xrootMd(kk)-1.0
	                nref(kk)=nint(xii-float(iw4(kk))/2.-0.5+asymm(kk))
c	write (*,*) 'kk,k:',kk,k
c	write (*,*) 'xii,nref(kk):',xii,nref(kk)
	                if (nref(kk).lt.IntLL(kk)) goto 11           ! t-range
	                if ((nref(kk)+iw4(kk)).ge.IntUL(kk)) goto 11 ! t-range						   	 
	                goto 7308 
	             endif 
	          enddo !k
	          goto 50                           ! failure to find a iCF-pt
 7308		      continue
	       enddo !kk
c
c=================================================================================     
c			   
c
	       if (iw4(2).ge.3) then
	          do kkk=1,iw4(2)
	             yMd2(kkk)=dble(ChInt(2,nref(2)+kkk))
	          enddo !kkk
c	write (*,*) 'debuging Ch2'
c	write (*,*) 'isess,iwvfm,isegm,iw4(2)',isess,iwvfm,isegm,iw4(2) 
c     write (*,*) 'yMd2:',(yMd2(kkk),kkk=1,iw4(2))
c     write (*,*) 'kk,ChInt(2,kk):',
c    *            (kk, ChInt(2,kk),kk=IntLL(2),IntUL(2))
c	write (*,*) 'valMd(2)', valMd(2)
c	pause
                call Root
     *          (iw4(2),yMd2,Q42,valMd(2),xrootMd(2),firstdMd2,parMd02,
     *          ierrMd2)
	          if (ierrMd2.gt.0) goto 52 ! failure to locate iCF-pt 
			                            ! by interpolation of start segment
	       endif
c
	       if (iw4(1).ge.3) then
	          do kkk=1,iw4(1)
	             yMd1(kkk)=dble(ChInt(1,nref(1)+kkk))
	          enddo !kkk
c	write (*,*) 'debuging Ch1'
c	write (*,*) 'isess,iwvfm,isegm,iw4(1)',isess,iwvfm,isegm,iw4(1)	      
c     write (*,*) 'yMd1:',(yMd1(kkk),kkk=1,iw4(1))
c     write (*,*) 'kk,ChInt(1,kk):',
c    *            (kk, ChInt(1,kk),kk=IntLL(1),IntUL(1))
c	write (*,*) 'valMd(1)', valMd(1)
c	pause
                call Root
     *          (iw4(1),yMd1,Q41,valMd(1),xrootMd(1),firstdMd1,parMd01,
     *          ierrMd1)
	          if (ierrMd1.gt.0) goto 51  ! failure to locate iCF-pt by 			                               
			                             ! interpolation of stop segment
	       endif
c
             do kk=1,2
 	          xrootInt(kk)=sngl(xrootMd(kk))
	          QtyX(kk)=xrootInt(kk)-float(iw4(kk))/2.0
		   enddo !kk
c
             do kk=1,2
                ValMdU(kk)=CFiU(kk)*ChInt(kk,IntUL(kk))
		      do k=IntLL(kk),IntUL(kk)
	             if (ChInt(kk,k).ge.ValMdU(kk)) then
	                WidthQty(kk)=(ValMdU(kk)-ChInt(kk,k-1))/
     /                (ChInt(kk,k)-ChInt(kk,k-1))+float(k-1)- 
	-                float(nref(kk))-sngl(xrootMd(kk))
	                goto  6667
	                endif
	           enddo !k
	           goto 50                     ! failure to find an upper iCF-pt
 6667			   continue
             enddo !kk
c
c	          do k=IntLL(kk),IntUL(kk)
c	             if (ChInt(kk,k).gt.FracInt+0.00001) then
c	                QtyX(kk)=(FracInt-ChInt(kk,k-1))/
c     /                (ChInt(kk,k)-ChInt(kk,k-1)) 
c	                xrootInt(kk)=float(k-1)+QtyX(kk)
c	                goto 6666
c	             endif
c	          enddo !k
c6666			  continue
c
C
C	do kk=1,2
C	   write (*,*) 'isess,iwvfm,isegm,kk:',isess,iwvfm,isegm,kk 
C	   do k=IntLL(kk),IntUL(kk)
C	      write (*,*) k, ChInt(kk,k)/ChInt(kk,IntUL(kk))
C	   enddo !k	   
C	enddo !kk
c
c            Exclusion due to a low logarithmic derivative
c	            
c		   logder1=(firstd1+firstd1a)/(val1-dble(amean(1)))/2.d0
c	       logder2=(firstd2+firstd2a)/(val2-dble(amean(2)))/2.d0
c	       if (logder1.lt.logderlim1) goto 60         ! too small log.der.
c	       if (logder2.lt.logderlim2) goto 60 		  ! too small log.der.
c
c            Incrementing the positron-lifetime spectrum
c													   
c	       aux=sngl(xroot1-xroot2)-
c    -       (sngl(Slope(1))*PulseHT(1)+sngl(Slope(2))*PulseHT(2))/250.
c            khi=
c    *       int((aux+float(kbest1-kbest2))*80.+1600.)
c	       if ((khi.gt.0).and.(khi.le.5120)) ihi(khi)=ihi(khi)+1
c
c
c            Incrementing the histograms for logarithmic derivative
c            at the CF points
c
C$	       khi=nint(1000.*sngl(logder1))
C$	       if ((khi.ge.1).and.(khi.le.1000)) 
C$   *       ihiLogDer(1,khi)=ihiLogDer(1,khi)+1               	 
C$	       khi=nint(1000.*sngl(logder2))
C$	       if ((khi.ge.1).and.(khi.le.1000)) 
C$   *       ihiLogDer(2,khi)=ihiLogDer(2,khi)+1
c
c
             isegmd=isegmd+1
	       if (isegmd.gt.nsegmd) goto 4321
c
c            Normalize the PH of the current segment pair and write it
c
c	       do k=1,nsamp
c	          ysegm1=
c    *          (float(ch(1,k))-amean(1))/(amean(1)-sngl(yextr1))
c	          xsegm1=float(k-kbest1+ksh2(1)+1)-xroot1
c	          ysegm2=
c    *          (float(ch(2,k))-amean(2))/(amean(2)-sngl(yextr2))
c	          xsegm2=float(k-kbest2+ksh2(2)+1)-xroot2
c	       write (3,9191) 0.25*xsegm1,ysegm1,0.25*xsegm2,ysegm2
 9191        format (f9.4,f7.3,f9.4,f7.3)		    
c	       enddo !k
c		   write (3,*)
c
c            Normalize the areas of the current segment pair and write the pair
c

	       do k=1,nsamp
	          ysegm1=					 
     *          (float(ch(1,k))-amean(1))/ChInt(1,IntUL(1))
	          xsegm1=float(k-kbest1-nref(1))-xrootInt(1)
	          ysegm2=
     *          (float(ch(2,k))-amean(2))/ChInt(2,IntUL(2))
	          xsegm2=float(k-kbest2-nref(2))-xrootInt(2)
	          write (3,9191) 0.25*xsegm1,ysegm1,0.25*xsegm2,ysegm2
	       enddo !k
	       write (3,*)
c
c            Write the current normalized integrated segment of detector 1
c
	       do k=IntLL(1),IntUL(1)
	          yIsegm1=ChInt(1,k)/ChInt(1,IntUL(1))
	          xsegm1=float(k-nref(1))-xrootMd(1)
	       write (13,9192) 0.25*xsegm1,yIsegm1	    
 9192        format (f9.4,f7.4)		    
	       enddo !k
		   write (13,*)
c
c            Write the current normalized integrated segment of detector 2
c
	       do k=IntLL(2),IntUL(2)
	          yIsegm2=ChInt(2,k)/ChInt(2,IntUL(2))
	          xsegm2=float(k-nref(2))-xrootMd(2)
	       write (23,9192) 0.25*xsegm2,yIsegm2	    
	       enddo !k
		   write (23,*)								  
 4321        continue
             xxhi=xrootInt(1)-xrootInt(2)+
     +       float(kbest1-kbest2+nref(1)-nref(2))
	       xxhi=xxhi-WidthQty(2)*SlopeX2+WidthQty(1)*SlopeX1
c
c            A WATCH DOG for remedy of an existing error in the ACQ code  
c            
c     	   do iev=1,nev
c	          if (Qlist(iev).eq.xxhi) goto 8899	! excluding  the current event
c	       enddo !iev
c		   Qlist(nev+1)=xxhi
c		   nev=nev+1	 
c
             Ovr1=xrootInt(1)+float(kbest1+nref(1))-
     -       float(int(xrootInt(1)+float(kbest1+nref(1))))
             Ovr2=xrootInt(2)+float(kbest2+nref(2))-
     -       float(int(xrootInt(2)+float(kbest2+nref(2))))
             write (8,2191) xrootInt(1)+float(kbest1+nref(1))+Ovr1*cor1,
     *                      xrootInt(2)+float(kbest2+nref(2))+Ovr2*cor2
 2191        format (2f9.3)
c
c            Incrementing the delayed-coincidence spectrum from time-integrated signals
c            (no corrections for even-odd oscillation)             	  
c     
             kkhi=
     =       int((xxhi+Ovr1*cor1-Ovr2*cor2)*80.+2560.-StpStrSpac*80.)			 
	       if ((kkhi.gt.0).and.(kkhi.le.5120)) 
     *       ihiInt(kkhi)=ihiInt(kkhi)+1
c
c		   Write "xxhi" vs "WidthQty(2)-WidthQty(1)"
c
             if (iitems.lt.nitems) then
		      write (61,6161) 250.*xxhi,250.*(WidthQty(2)-WidthQty(1))
c		      write (61,6161) 250.*xxhi,250.*WidthQty(1)
	        endif
 6161         format (f14.1,f11.1)
c
c
c            Increment the histogram of the selected ad hoc quantity
c            ... in this case the detection time difference with bin width of 1 ps
c
	       khi=
     =       dint(250.d0*dble(xrootInt(1))+1000.d0)-1000
     +       250.*(kint(1)+nref(1)-kint(2)-nref(2))
      	   if ((khi.lt.-10000).and.(khi.gt.-20000))
     *       AdHocHi(khi)=AdHocHi(khi)+1  			 
c
             if (iitems.lt.nitems) then
	         aux=xrootInt(1)-xrootInt(2)+
     +         float(kint(1)-kint(2)+nref(1)-nref(2))
	         iitems=iitems+1
c			 write (6,8889) xrootInt(1), 
	         write (6,8889) ChInt(2,IntUL(2)), 
	*         250.*(xrootInt(1)+float(kint(1)+nref(1)))-
     +         250.*(xrootInt(2)+float(kint(2)+nref(2)))
 8889          format (3f12.4)
c
	         SumMod500=
	*         250.*(xrootInt(1)+float(kint(1)+nref(1)))+
     -         250.*(xrootInt(2)+float(kint(2)+nref(2)))
               SumMod500=
     =         SumMod500-float(int(SumMod500/500.))*500.
	         Diff=250.*(xrootInt(1)+float(kint(1)+nref(1)))-
     -         250.*(xrootInt(2)+float(kint(2)+nref(2)))
               write (7,8889) SumMod500,Diff
c
c      if ((abs(diff+15087.030).lt.0.05).and.
c	*   (abs(SumMod500-481.3516).lt.0.05)) then
c         write (5,*)
c	   write (5,*) 'isess,iwvfm,isegm:',isess,iwvfm,isegm
c	   write (5,*) 'kint(1),kint(2):',kint
c	   write (5,*) 'nref(1),nref(2):',nref
c	   write (5,*) 'xrootMd(1),xrootMd(2):',xrootMd
c	endif
     
c
c*******************************************************************************
c                                                                              *
c              The next if-statement is temporarily skipped ... 				 *
c			 																 *
               goto 7779 
			 if ((dfloat(aux*250.).ge. Qll).and.
     *            (dfloat(aux*250.).lt.Qul)) then
	            nQitems=nQitems+1
	            do kk=1,2
		   	      Qmea1(kk)=Qmea1(kk)+dfloat(250.*WidthQty(kk))
		  	      Qvar1(kk)=Qvar1(kk)+dfloat(250.*WidthQty(kk))**2
			  	  Qcov(kk)=Qcov(kk)+dfloat(250.*aux*250.*WidthQty(kk))
	            enddo !kk
			    Qmea2=Qmea2+dfloat(250.*aux)
	            Qvar2=Qvar2+dfloat(250.*aux)**2
	         endif
c																		     *
c*******************************************************************************
c	   
 7779		      continue    
		   endif
             mon=mon+1
	       goto 8888
   10        continue ! (out of time or PH range)
             mon1=mon1+1
	       goto 8888
   11        continue ! (out of time range for interpolation)
             mon1a=mon1a+1
	       goto 8888
   20        continue ! (failure of parabolic fit)
c            write (*,*) 'ierr1, ierr2, ierr1a, ierr2a: ',
c    *                    ierr1,ierr2,ierr1a,ierr2a 
		   mon2=mon2+1
	       goto 8888
   30        continue ! (too noisy baseline)
             mon3=mon3+1
	       goto 8888
   40        continue ! (out of PH windows)
             mon4=mon4+1
	       goto 8888
   50        continue ! (failure in finding CF point)
             mon5=mon5+1
	       goto 8888
   51        continue ! (failure to locate the CF point by non-linear 
                      ! interpolation of stop segment)
             mon5a=mon5a+1
	       goto 8888
   52        continue ! (failure to locate the CF point by non-linear 
                      ! interpolation of start segment)
             mon5b=mon5b+1
	       goto 8888
   60        continue ! (too small log. der.)
             mon6=mon6+1
   80        continue ! (failure due to a wrong config. of pts. at 
                      ! leading edge(s))
		   mon7=mon7+1
	       goto 8888
c8899        continue							 
             write (*,*) 'Wrong isees,iwvfm,isegm:',isees,iwvfm,isegm
	       moniwrong=moniwrong+1
	       goto 8888
c            
 8888        continue
c         
	    enddo !isegm
	    goto 221
   22	    write (*,*) 'Error while opening file '
          write (*,*) filename1
	    write (*,*) 'or'
          write (*,*) filename2
  221		continue
	enddo !iwvfm
	close (unit=1,status='keep')		   
	write (*,*) 'moniwrong:',moniwrong					   
	do khi=-20000,-10000
	   write (8,7531) khi,AdHocHi(khi)
 7531	   format (2i7) 
	enddo !ihi
c
      open (unit=4,file='AreaSpectr'//scan//'.dat',status='new')
	do k=1,3000   
	   write (4,303) k,ihiarea(1,k),ihiarea(2,k)
	enddo !k
  303 format (3i6)
	close (unit=4,status='keep')
	do k=1,10000
	   write (33,304) k,IhiIntSgnl(1,k),IhiIntSgnl(2,k)
  304 format (i5,2i8)
  	enddo !k

c
      close (unit=3,status='keep')
      close (unit=13,status='keep')
      close (unit=23,status='keep')
      close (unit=33,status='keep')
	close (unit=5,status='keep')
	close (unit=6,status='keep')								   
	close (unit=61,status='keep')								   
	close (unit=7,status='keep')
	close (unit=8,status='keep')
c
c*******************************************************************************
c                                                                              *
c              The next if-statement is temporarily skipped ... 				 *
c			 																 *
               goto 7778
c
c     Determining regression slopes
c    
      do kk=1,2
	   Qmea1(kk)=Qmea1(kk)/dfloat(nQitems)
 	   Qvar1(kk)=Qvar1(kk)/dfloat(nQitems)
	   Qcov(kk)=Qcov(kk)/dfloat(nQitems)
	enddo !kk
	Qmea2=Qmea2/dfloat(nQitems)
 	Qvar2=Qvar2/dfloat(nQitems)
      do kk=1,2
	   Qvar1(kk)=Qvar1(kk)-Qmea1(kk)**2
	   Qcov(kk)=Qcov(kk)-Qmea2*Qmea1(kk)
	enddo !kk
	Qvar2=Qvar2-Qmea2**2
	write (*,*) 'Qmea2,Qmea1(1),Qmea1(2):',Qmea2,Qmea1
	write (*,*) 'Qvar2,Qvar1(1),Qvar1(2):',Qvar2,Qvar1
c
      do kk=1,2
         QA(1,1)=Qvar1(kk)
	   QA(2,2)=Qvar2
	   QA(1,2)=Qcov(kk)
	   QA(2,1)=QA(1,2)
	   call	InvertMatr_2x2 (QA,QAinv,ifailInv2)
	   if (ifailInv2.ne.0) then
	      write (*,*) 'Inverting matrix QA failed'
	      write (*,*) 'ifailInv2:',ifailInv2
		  stop
	   endif
	   Qslope(kk)=-QAinv(1,2)/QAinv(2,2)
	enddo !kk      	   
	write (*,*) 'Qslope(1),Qslope(2):',Qslope
c
 7778	continue
c																			 *
c*******************************************************************************                                                                            
c
C$	enddo !k
C$	close (unit=1,status='keep')
c
c     Writing the positron-lifetime spectrum deduced from integrated signals 
c
	open (unit=1,file='PLTspectrumInt'//scan//'.dat',
     *status='new')
	do k=1,5120
	   write (1,300) 3.125*float(k),ihiInt(k)
  300    format (f10.3,i10)
	enddo !k
	close (unit=1,status='keep')
c
c*******************************************************************************
c																			 *
c     Temporarily skipped 													 *
c     																		 *
c     goto 7777                                                                         
	call Resolution(ihiInt,5120,0.2d0,Pos,FW,SigFW,ierrRes)
	if (ierrRes.eq.0) then
	   write (*,*) 'Pos,FW,SigFW:',Pos,FW,SigFW
	   else
	   write (*,*) 'ierrRes:', ierrRes
	endif
c7777 continue																		 
c																			 *
c*******************************************************************************
c
	open (unit=1,file='Details_Scan'//scan//'.ptc',
     *status='new')
c
	write (1,*) 'SCAN No.:', iscan
	write (1,*) 'Scanning code used: ',
     *            'Scanning60CoWaveforms_UniversalOption.f'
	write (1,*) '                    ',
     *            'Algorithm version from August 11, 2005'
      write (1,*) description
c
	write (1,*) ' '
	write (1,*) 'ADJUSTED PARAMETERS'
	write (1,*) 'nsamp:', nsamp
	write (1,*) 'nsegm:', nsegm
	write (1,*) 'nwvfm:', nwvfm
	write (1,*) 'nsess:', nsess
	write (1,*) 'nitems:', nitems
	write (1,*) 'nsegmd:',nsegmd
c
	write (1,*) 'iw1(1), iw1(2):',iw1
	write (1,*) 'iw2(1), iw2(2):',iw2
	write (1,*) 'iw3(1), iw3(2):',iw3
	write (1,*) 'iw4(1), iw4(2):',iw4
	write (1,*) 'ksh2(1), ksh2(2):',ksh2
	write (1,*) 'ksh3(1), ksh3(2):',ksh3
	write (1,*) 'asymm(1), asymm(2):',asymm
	write (1,*) 'IntLL(1), IntLL(2):',IntLL
	write (1,*) 'IntUL(1), IntUL(2):',IntUL
	write (1,*) 'CFi:', CFi
	write (1,*) 'WiL1,WiL2:',WiL1,WiL2
	write (1,*) 'WiU1,WiU2:',WiU1,WiU2
	write (1,*) 'WiIntL(1),WiIntL(2):',WiIntL
	write (1,*) 'WiIntU(1),WiIntU(2):',WiIntU
	write (1,*) 'Varlim1,Varlim2:',sqrt(Varlim1),sqrt(Varlim2)
	write (1,*) 'SlopeX1, SlopeX2:',SlopeX1,SlopeX2	
	write (1,*) 'cor1, cor2:',cor1,cor2	
	write (1,*) 'StpStrSpac:',StpStrSpac
	write (1,*) 'Path:',Path	
c
      write (1,*)
      write (1,*) ' STATISTICS'
	write (1,*) ' The number of segment pairs analyzed:        ',
     *              nsess*nwvfm*nsegm
	write (1,*) ' The number of usefull segments:              ',mon
      write (1,*) ' Out of time or PH range         :            ',mon1
	write (1,*) ' Out of time range for interpolation:		   ',mon1a
      write (1,*) ' Failure of parabolic fit:                    ',mon2
      write (1,*) ' Too noisy baseline:                          ',mon3
      write (1,*) ' Out of PH and area window(s):                ',mon4
	write (1,*) ' Failure to find the iCF point in allowed t-region:',
     *              mon5
	write (1,*) ' ... to locate it in stop segm. by iterpolation:   ',
     *              mon5a
	write (1,*) ' ... to locate it in start segm. by iterpolation: ',
     *              mon5b
c	write (1,*) ' Too small logarithmic derivative(s):         ',mon6
c	write (1,*) ' A wrong configuration of leading edge pts.:  ',mon7
      write (1,*) ' A number of wrong waveform pairs:            ',
     *              moniwrong
c
      write (1,*) ' '
      if (ierrRes.eq.0) then
	   write (1,*) ' RESOLUTION'
	   write (1,*) ' Pos,FW,SigFW:',Pos,FW,SigFW
	endif
      write (1,*) ' '
c
      close (unit=1,status='keep')		
c
C$	open (unit=1,file='LogDer_Scan'//scan//
C$   *'.dat',status='new')
C$	do khi=1,1000
C$	   write (1,998) 4.*float(khi)/1000.,
C$   *   ihiLogDer(1,khi),ihiLogDer(2,khi)
C$998    format (f10.4,2i10)
C$	enddo !khi
C$    close (unit=1,status='keep')
      stop
  222	write (*,*) 'Error while reading a binary file. Job terminated.'
      write (*,*) 'iwvfm:',iwvfm,' isegm:',isegm
	stop				
	end
c
************************************************************************
      Subroutine Resolution(ihi,l,crit,Pos,FW,SigFW,ierr)
c***********************************************************************
c
      integer*4 ihi(1),i,i0,i1,i2,n,l,ihmax,ihcrit
	integer   ierr
      real*8    crit,FW,SigFW,A(3,3),B(3,3),RHS(3),par(3),Pos
c
      ierr=0
      ihmax=0
      do i=1,l
	   if (ihi(i).gt.ihmax) then
	      i0=i
	      ihmax=ihi(i)
	   endif
	enddo !i
	write (*,*) 'i0,ihmax',i0,ihmax
	if (ihmax.le.5) goto 3
      ihcrit=dint(crit*dfloat(ihmax))
	write (*,*) 'ihcrit',ihcrit
      do i=1,i0
	   if (ihi(i).gt.ihcrit) then
	      i1=i			  
	      goto 1
	   endif
	enddo !i
    3 ierr=1
	return
    1 continue
      write (*,*) 'i1',i1
      if (ihi(i1).le.5) then
         ierr=2
	   return
      endif
      do i=i0,l
	   if (ihi(i).lt.ihcrit) then
	      i2=i
	      goto 2
	   endif
	enddo !i
	ierr=3
	return 
    2 continue
      write (*,*) 'i2',i2
      if (ihi(i2).le.5) then
	   ierr=4
	   return
	endif
	n=i2-i1+1
	write (*,*) 'n',n
	do j=1,3
	   do jj=1,3				    
	      A(j,jj)=0.d0
	      do i=1,n
	         if (ihi(i+i1-1).le.5) then
	write (*,*) 'i,ihi(i+i1-1)',i,ihi(i+i1-1)     
	            ierr=5
	            return
	         endif
	         A(j,jj)=A(j,jj)+dfloat(ihi(i+i1-1))*dfloat(i)**(j+jj-2)
	      enddo !i
	   enddo !jj
	enddo !j
	do j=1,3
	   RHS(j)=0.d0
	   do i=1,n
	      RHS(j)=RHS(j)+
     +      dfloat(ihi(i+i1-1))*dlog(dfloat(ihi(i+i1-1)))*
     *      dfloat(i)**(j-1)
	   enddo !i
	enddo !j
	call InvertMatr_3x3(A,B,ifail)
	if (ifail.ne.0)	then 
	   ierr=6
	   return
	endif
	do j=1,3
	   par(j)=0.d0
	   do jj=1,3
	      par(j)=par(j)+B(j,jj)*RHS(jj)
	   enddo !jj
      enddo !j
	if (par(3).ge.0.d0) then
	   ierr=7
	   return
	endif
	Pos=(-par(2)/par(3)/2.d0+dfloat(i0-1))*3.125d0
	FW=dsqrt(-4.d0*dlog(2.d0)/par(3))*3.125d0
	SigFW=-dsqrt(-dlog(2.d0)/par(3))/par(3)*
     *dsqrt(B(3,3))*3.125d0
	return
	end
c 
c***********************************************************************
      Subroutine ProduceMatrix_3xN(n,Q,ifail)
c***********************************************************************
c
	integer n
	real*8 Q(3,128),A(3,3),B(3,3)	 
c
      do j=1,3
	   do jj=1,3
	      A(j,jj)=0.d0
	      do i=1,n
	         A(j,jj)=A(j,jj)+dfloat(i)**(j+jj-2)
	      enddo !i
	   enddo !jj
	enddo !j

	call InvertMatr_3x3(A,B,ifail)
	if (ifail.ne.0) goto 1
	do j=1,3
	   do i=1,n
	      Q(j,i)=0.d0
	      do jj=1,3
	         Q(j,i)=Q(j,i)+B(j,jj)*dfloat(i)**(jj-1)
	      enddo !jj
	   enddo !i
	enddo !j
    1 return
	end
c
c***********************************************************************
      Subroutine InvertMatr_3x3(A,B,ifail)
c***********************************************************************
c
      Real*8 A(3,3),B(3,3),y(128)
c
      k=0
      do i=1,3
	   do j=1,i
	      k=k+1
	      y(k)=A(i,j)
	   enddo !j
	enddo !i
      m=3
      call INVSPD(m,y,ifail)
	if (ifail.ne.0) goto 1
 	k=0
      do i=1,3
	   do j=1,i
	      k=k+1
	      B(i,j)=y(k)
	      B(j,i)=y(k)
	   enddo !j
	enddo !i	
    1 return 
	end
c***********************************************************************
      Subroutine InvertMatr_2x2 (A,B,ifail)
c***********************************************************************
c
      Real*8 A(2,2),B(2,2),y(128)
c
      k=0
      do i=1,2
	   do j=1,i
	      k=k+1
	      y(k)=A(i,j)
	   enddo !j
	enddo !i
      m=2
      call INVSPD(m,y,ifail)
	if (ifail.ne.0) goto 1
 	k=0
      do i=1,2
	   do j=1,i
	      k=k+1
	      B(i,j)=y(k)
	      B(j,i)=y(k)
	   enddo !j
	enddo !i	
    1 return 
	end
c***********************************************************************
      Subroutine ParabExtreme(n,y,Q,xextreme,yextreme,secder,ierr)
c***********************************************************************
c
c     n              -- number of points
c     y(1) thru y(n) -- y-values for x=1 thru x=n 
c     xextreme       -- x for the extreme of y
c     yextreme       -- the extreme of y
c	  ierr=0         -- the trial is successful
c	  1              -- no extreme within the fitted interval
c     2              -- the extreme in infinity
c
      real*8 xextreme,yextreme,secder,x,y(1),par(3),Q(3,128)
      integer n,ierr
c
	  ierr=0
	  do j=1,3
	    par(j)=0.d0
	    do i=1,n
	       par(j)=par(j)+Q(j,i)*y(i)
     	   enddo !i
 	  enddo !j
	  if (par(3).eq.0.d0) then
         ierr=2
	     return	
      endif  
	  x=-par(2)/2.d0/par(3)
	  if ((x.ge.dfloat(n)).or.(x.le.1.d0)) then 
	    ierr=1
	    return
	    else
	    xextreme=x
      	yextreme=par(1)+par(2)*xextreme+par(3)*xextreme**2
		secder=2.d0*par(3)
	    return
	  endif
	  end
c
c
c***********************************************************************
      Subroutine Root(n,y,Q,val,xroot,firstder,par0,ierr)
c***********************************************************************
c
c     n              -- number of points
c     y(1) thru y(n) -- y-values for x=1 thru x=n 
c     val            -- set value of y
c     xroot          -- value of x for which y reaches val
c     firstder       -- 1st derivative of y(x) at x=xroot
c	  ierr=0         -- the trial is successful
c	  1              -- the parabola does not intersect val
c     2              -- none or two intersections with val within 
c                       the interval x=1 to x=n
c
      real*8 xroot,y(1),x1,x2,xtmp,discr,par(3),Q(3,128),dn,val,
	*       firstder,par0
	integer n,ierr
c
	ierr=0
	dn=dble(n)
	do j=1,3
	   par(j)=0.d0
	   do i=1,n
	      par(j)=par(j)+Q(j,i)*y(i)
     	   enddo !i
	enddo !j
	par0=par(1)
	discr=par(2)**2-4.d0*par(3)*(par(1)-val)
	if (discr.lt.0.d0) then
	   ierr=1
	   return
	endif
	discr=dsqrt(discr)
	x1=(-par(2)+discr)/2.d0/par(3)
	x2=(-par(2)-discr)/2.d0/par(3)
	if (x1.gt.x2) then
	   xtmp=x1
	   x1=x2
	   x2=xtmp
	endif
	if ((x2.lt.1.d0).or.(x1.gt.dn).or.
	*   (x1.lt.1d0.and.x2.gt.dn).or.(x1.ge.1.d0.and.x2.le.dn)) then
         ierr=2
	   return
	endif
	if (x1.lt.1.d0) then
	   xroot=x2
	   firstder=par(2)+2.d0*par(3)*xroot
	   return
	   else
	   xroot=x1
	   firstder=par(2)+2.d0*par(3)*xroot
	   return
	endif
	end          
c
c***********************************************************************
      SUBROUTINE INVSPD(N,A,IFAIL)
c***********************************************************************
c
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1)
      DIMENSION PP(30),Q(30),S(30)
      IFAIL=0
      IF(N.LT.1)GO TO 100
      IF(N.GT.30)GO TO 100
c 
      DO 8 I=1,N
      IX=I*(I+1)/2
      SI=A(IX)
      IF(SI-1.0D-30)100,100,8
    8 S(I)=1.0D0/SQRT(SI)
      IX=0
      DO 20 I=1,N
      DO 20 J=1,I
      IX=IX+1
   20 A(IX)=A(IX)*S(I)*S(J)
c 
      KX=0
      DO 65 I=1,N
      IX=KX
      KX=KX+I
c 
      Q(I)=1.0D0/A(KX)
      PP(I)=1.0D0
      A(KX)=0.0D0
      KP1=I+1
      KM1=I-1
      IF(KM1)100,50,40
   40 DO 49 J=1,KM1
      IX=IX+1
      PP(J)=A(IX)                                                      
      Q(J)=A(IX)*Q(I)
   49 A(IX)=0.0D0
   50 IF(I-N)51,60,100
   51 IX=IX+1
      DO 59 J=KP1,N
      IX=IX+J-1
      PP(J)=A(IX)
      Q(J)=-A(IX)*Q(I)
   59 A(IX)=0.0D0
c 
   60 DO 65 J=1,N
      DO 65 K=J,N
      IX=K*(K-1)/2+J
   65 A(IX)=A(IX)+PP(J)*Q(K)
c 
      IX=0
      DO 70 J=1,N
      DO 70 K=1,J
      IX=IX+1
   70 A(IX)=A(IX)*S(K)*S(J)
      RETURN
c 
100   IFAIL=1
      RETURN
      END
c
c*******************************************************************************