/*
    Copyright 2008-2009 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file gpl-3.0.txt. If not, see
    <http://www.gnu.org/licenses/>.
*/

#include "emea.h"

#include <QtCore/QDebug>

#include <compactcsv.h>
#include <resulttospectrum.h>

class EMEAEpos : public EMEABase
{
	public:
		EMEAEpos( QObject* p ) : EMEABase( p ) {
			qDebug() << "EMEAEpos::EMEAEpos(" << p << ")";
		}

		void setupChain( int threads ) {
			qDebug() << "EMEAEpos::setupChain(" << threads << "(ignored) )";
			addToChainStart( objectInNewThread<NSDiskIO::CompactCSVReader>() );
			NSSpectrum::ResultsToSpectrum* res = new NSSpectrum::ResultsToSpectrum( this );
			connect( res, SIGNAL( newSpectrum( NSSpectrum::AbstractSpectrumModel* ) ),
					this, SIGNAL( newSpectrum( NSSpectrum::AbstractSpectrumModel* ) ) );
            addToChain( res->chainmembers(), false );
			addToGui( res );
		}
};

EMEA_MAIN( EMEAEpos );

