/*
    Copyright 2008-2009 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file gpl-3.0.txt. If not, see
    <http://www.gnu.org/licenses/>.
*/

#include "emea.h"

#include <QtCore/QDebug>

#include <eposbin.h>
#include <resulttospectrum.h>
#include <thread_template.h>

class EMEAStripped : public EMEABase
{
	public:
		EMEAStripped( QObject* p ) : EMEABase( p ) {
			qDebug() << "EMEAStripped::EMEAStripped(" << p << ")";
		}

		void setupChain( int threads ) {
			qDebug() << "EMEAStripped::setupChain(" << threads << ")";
			addToChainStart( objectInNewThread<NSDiskIO::EPOSBinReader>() );
			NSSpectrum::ResultsToSpectrum* res = new NSSpectrum::ResultsToSpectrum( this );
			connect( res, SIGNAL( newSpectrum( NSSpectrum::AbstractSpectrumModel* ) ),
					this, SIGNAL( newSpectrum( NSSpectrum::AbstractSpectrumModel* ) ) );
            addToChain( res->chainmembers(), false );
			addToGui( res );
		}
};

EMEA_MAIN( EMEAStripped );

