/*
    Copyright 2008-2011 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file gpl-3.0.txt. If not, see
    <http://www.gnu.org/licenses/>.
*/

#include "emea.h"

#include <QtCore/QDebug>

#include <tabulatedstatistics.h>
#include <evaluationpath.h>
#include <csvforprinting.h>

class EMEAStatistical : public EMEABase
{
	public:
		EMEAStatistical( QObject* p ) : EMEABase( p ) {
			//qDebug() << "EMEAStatistical::EMEAStatistical(" << p << ")";
		}

		void setupChain( int threads ) {
			qDebug() << "EMEAStatistical::setupChain(" << threads << ")";
			addToChainStart( objectInNewThread<NSCore::TabulatedStatistics>() );
			QList<NSCore::DataSetChainMember*> evals;
			for ( int i=0; i<threads; ++i )
				evals << new NSEvaluation::EvaluationPath( this );
			addToChain( evals );
			//addToChain( new NSDiskIO::CombinedCSV( this ) );
			addToChain( new NSDiskIO::MergeCSV( this ) );
		}
};

EMEA_MAIN( EMEAStatistical );

