/*
    Copyright 2009-2009 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef QTREEITEMMODELV3_H
#define QTREEITEMMODELV3_H

#include <QtCore/QAbstractItemModel>

namespace NSCore
{

	class QTreeItem;
	class RootItem;

	class QTreeItemModelV3 : public QAbstractItemModel
	{
		Q_OBJECT
		public:
			QTreeItemModelV3( QObject* );
			~QTreeItemModelV3();

			void addToRootItem( NSCore::QTreeItem* );

			int columnCount( const QModelIndex& =QModelIndex() ) const;
			int rowCount( const QModelIndex& =QModelIndex() ) const;

			QModelIndex index( int row, int column, const QModelIndex& =QModelIndex() ) const;
			QModelIndex parent( const QModelIndex& ) const;

			QVariant data( const QModelIndex&, int =Qt::DisplayRole ) const;

		private:
			RootItem* d;

			void addChilds( NSCore::QTreeItem*, QString prefix ="" );
	};

} // namespace NSCore

#endif // QTREEITEMMODELV3_H
