/*
    Copyright 2005-2009 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.

*/

#include <cmath>
#include <cstdlib>

namespace NSCore {

// Get the randoms in gauss-distribution from the polar-method (faster than box-muller)
// see http://de.wikipedia.org/wiki/Normalverteilung#Simulation_normalverteilter_Zufallsvariablen
double polarmethodrandom() {
	double u1, u2;
	double v = 2;
	while ( v >= 1 ) {
		u1 = rand()*1.0/RAND_MAX;
		u2 = rand()*1.0/RAND_MAX;
		v = pow( 2*u1-1, 2 ) + pow( 2*u2-1, 2 );
	}
	return ( 2*u1-1 )*sqrt( -2*log( v )/v );
}

};
