
#ifndef DOUBLECONVERSIONTEST
#define DOUBLECONVERSIONTEST

#include <QtTest/QtTest>

//#include <datatypes.h>

//using namespace NSCore;

class DoubleConversionTest : public QObject
{
	Q_OBJECT
	char c[1000];
	double d[1000];
	private slots:
		void initTestCase() {
		}
		void cleanupTestCase() {
		}
		void init() {
			for ( int i=0; i<1000; ++i ) c[i] = char( rand() % 256 ) - 127;
		}
		void calculation() {
			QBENCHMARK {
				for ( int i=0; i<1000; ++i ) {
					d[i] = c[i] * 0.025 + 0.3;
				}
			}
		}
		void simpleconversion() {
			QBENCHMARK {
				for ( int i=0; i<1000; ++i ) {
					d[i] = c[i];
				}
			}
		}
		void manualdoubleconversion() {
			QWARN( "The manual conversion isn't working..." );
			for ( int i=0; i<1000; ++i ) {
				d[i] = c[i];
			}
			/*QBENCHMARK {
				quint16* cd = (quint16*)d;
				for ( int i=0; i<1000; ++i ) {
					cd[ i ] = 0x3ff0 + 128*c[i];
					cd[ i+1 ] = 0;
					cd[ i+2 ] = 0;
					cd[ i+3 ] = 0;
				}
			}*/
		}
		void cleanup() {
			for ( int i=0; i<1000; ++i ) {
				//QCOMPARE( d[i], c[i] * 0.025 + 0.3 );
				QVERIFY( ( d[i] != 0.0 ) || ( c[i] == 0 ) );
				d[i] = 0;
			}
		}
};

#endif
