
#ifndef DATATYPESTEST
#define DATATYPESTEST

#include <unistd.h>

#include <QtTest/QtTest>

//#include <datatypes.h>
#include <statisticslogging.h>

using namespace NSCore;

class StatisticsAndLoggingTest : public QObject
{
    Q_OBJECT
    private:
        //NSCore::AcqisitionDataSet* data;
        StatisticsAndLogging* stats;
    private slots:
        void initTestCase() {
            //data = new NSCore::AcqisitionDataSet( 0,0 );
            stats = new StatisticsAndLogging();
        }
        void cleanupTestCase() {
            delete stats;
        }
        void firstvalue() {
            stats->addStatistics("first", 1.0);
            usleep(1E6);
            StatisticsAndLogging::statisticsmap map = stats->getStatistics();
            //qDebug() << map;
            QVERIFY(map.size() == 1);
            QVERIFY(map["first"] > 0.9 && map["first"] < 1.1);
        }
        void secondvalue() {
            stats->addStatistics("first", 1.0);
            stats->addStatistics("first", 2.0);
            stats->addStatistics("second", 2.0);
            usleep(1E6);
            StatisticsAndLogging::statisticsmap map = stats->getStatistics();
            //qDebug() << map;
            QVERIFY(map.size() == 2);
            QVERIFY(map["first"] > 2.9 && map["first"] < 3.1);
            QVERIFY(map["second"] > 1.9 && map["second"] < 2.1);
        }
        void mergemaps() {
            StatisticsAndLogging::statisticsmap additional;
            additional["first"] = 2.;
            stats->addStatistics("first", 1.);
            stats->addStatistics(additional);
            usleep(1E6);
            StatisticsAndLogging::statisticsmap map = stats->getStatistics();
            //qDebug() << map;
            QVERIFY(map.size() == 2);
            QVERIFY(map["first"] > 2.9 && map["first"] < 3.1);
            QVERIFY(map["second"] > -0.1 && map["second"] < 0.1);
        }
/*
        void checkEmptyDataSet() {
            QVERIFY( data->samples() == 0 );
            QVERIFY( data->channels() == 0 );
            QVERIFY( data->currentGenerationNumber() == 0 );
            QCOMPARE( data->getPrefix(), QString("/") );
            QCOMPARE( data->parentGeneration(), 0 );
            QCOMPARE( data->getRawData(), data->getRawChannel( 0 ) );
            QCOMPARE( data->getRawData(), data->getRawChannel( 1 ) );
        }
        void newDataSet() {
            delete data;
            data = new NSCore::AcqisitionDataSet( 1, 100 );
            for ( int i=0; i<100; ++i )
                data->getRawChannel( 0 )[i] = 0.0;
            data->updateMinMax();
            QCOMPARE( data->channels(), 1 );
            QCOMPARE( data->samples(), 100 );
            QCOMPARE( data->currentGenerationNumber(), 0 );
            QCOMPARE( data->getResultNames().size(), 4 );
            QCOMPARE( data->getRawData(), data->getRawChannel( 0 ) );
            QCOMPARE( data->getRawData() + 100, data->getRawChannel( 1 ) );
        }
*/
};

#endif
