/*
    Copyright 2005-2009 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ACQIRISLIVEREADER_H
#define ACQIRISLIVEREADER_H

#include "abstractfilereader.h"

namespace NSDiskIO {

	/**
	 * @brief Read AcqirisLive-Files
	 *
	 * This class reads AcqirisLive files which are always single-channel. So
	 * they aren't of much use except for first testing. :-(
	 */
	class AcqirisLiveReader : public AbstractFileReader {
		public:
			/// constructor
			/**
			 * You have to set the file to open with setFile( QString ).
			 */
			AcqirisLiveReader( QObject* );

		private:
			/// Read one dataset from the file
			NSCore::AcqisitionDataSet readSingleDataset();

			double _samplinginterval;
			double _channelfsr;
			double _fullscale;
			double _horizontalposition, _nexthorizontalposition;
			double _lsb;
			QList<double> _data;

			QTextStream _stream;
	};

};

#endif // ACQIRISLIVEREADER_H

