/*
    Copyright 2005-2009 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef EPOSTEXT_H
#define EPOSTEXT_H

#include "abstractfilereader.h"
#include "abstractfilewriter.h"

namespace NSDiskIO {

	/**
	 * @brief EPOS own format
	 */
	class EPOSWriter : public AbstractFileWriter {
		public:
			EPOSWriter( QObject* );

			void writeSingleDataset( NSCore::AcqisitionDataSet& data );

			void fileOpened( QIODevice* );
			void fileAboutToBeClosed( QIODevice* );

			QString debug() const { return "EPOSWriter"; }

		private:
			QTextStream _stream;
	};

	/**
	 * @brief Load EPOS own format
	 */
	class EPOSReader : public AbstractFileReader {
		public:
			EPOSReader( QObject* );
			QString filter() const { return "EPOS file (*.eposfile)"; }

			NSCore::AcqisitionDataSet readSingleDataSet();

			void fileOpened( QIODevice* );
			void fileAboutToBeClosed( QIODevice* );

			QString debug() const { return "EPOSReader"; }

		private:
			QTextStream _stream;

	};

};

#endif // EPOSTEXT_H

