/*
    Copyright 2007-2009 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>
                        Nicki Hinsche <nicvok@freenet.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef GAGEREADER_H
#define GAGEREADER_H

#include <abstractfilereader.h>

class GageReader : public NSDiskIO::AbstractFileReader
{
		public:
			GageReader( QObject* =0 );
			~GageReader();

			NSCore::AcqisitionDataSet readSingleDataSet();

			void fileOpened( QIODevice* );
			void fileAboutToBeClosed( QIODevice* );

			QString debug() const { return "GageReader"; }
		/*private:
			QString NewName(NSCore::ChannelDataSet*, QString filename() ) const;*/

		private:
			QDataStream _stream;

			QString _filename;
};

#endif // GAGEREADER_H

