/*
    Copyright 2005-2009 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.

*/

#include "plugins_interface.h"
#include "plugins_factory.h"

#include <math.h>

namespace NSEvaluation {

	Plugin::Plugin( NSCore::QTreeItem* p )
		: _config( 0 )
	{
		NSCore::TiParameter* tmp = dynamic_cast<NSCore::TiParameter*>( p );
		if ( tmp )
			_config = NSCore::TiParameterPointer( tmp );
		else
			_config = NSCore::TiParameterPointer( new NSCore::TiParameter( "options", QVariant::Invalid, p ) );
	}
	NSCore::TiParameterPointer Plugin::config() {
		return NSCore::TiParameterPointer( _config );
	}
	void Plugin::configChanged() {
		//qDebug() << "Plugin::configChanged() called the (empty) default implementation.";
	}


	PluginFactory_Client::PluginFactory_Client() {
		//qDebug() << "PluginFactory_Client::PluginFactory_Client()";
		PluginFactory::the()->registerClient( this );
	}

};

