/*
    Copyright 2005-2009 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef FANCYLISTVIEW_H
#define FANCYLISTVIEW_H

#include <QtCore/QObject>
#include <QtGui/QDialog>
#include <QtGui/QItemDelegate>
#include <QtGui/QStandardItemModel>
#include <QtGui/QAbstractItemView>

#include <QtXml/QDomElement>

class QWidget;
class QTreeWidgetItem;

class SettingsContainer;

class Ui_FancyListDialog;

class FancyListDialog : public QDialog
{
	Q_OBJECT
	public:

		struct ListItem {
			QString title;
			QString help;
			QString icon;
			QStringList categories;
		};

		FancyListDialog( const QString& title, const QString& desc, QWidget* );
		~FancyListDialog();

		void addItems( QList<ListItem> items );

		void addXmlItem( QDomElement );

		QString currentItem;

	private slots:
		void on_search_textEdited( const QString& );

		void selectionChanged( const QItemSelection& selected, const QItemSelection& deselected );

	private:
		Ui_FancyListDialog* d;
		QStandardItemModel* _model;
		QList<QStandardItem*> _categories;
		QList<QStandardItem*> _items;
};

#endif // FANCYLISTVIEW_H

