/*
    Copyright 2005-2009 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>
			Matthias Nagl <mnagl@uni-goettingen.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef QTREEITEMMODELDELEGATE_H
#define QTREEITEMMODELDELEGATE_H

#include <QtGui/QStyledItemDelegate>

/**
 * @brief Delegate to handle the specialities of the QTreeItemModel
 *
 * Attach this delegate to your views to get the special features handling QTreeItem-trees.
 * Otherwise the tree will not be completely usable. But it won't be unusable either...
 */
class QTreeItemModelDelegate : public QStyledItemDelegate
{
	Q_OBJECT
	public:
		QTreeItemModelDelegate( QObject* =0 );

		void paint( QPainter*, const QStyleOptionViewItem&, const QModelIndex& ) const;

		bool editorEvent( QEvent*, QAbstractItemModel*, const QStyleOptionViewItem&, const QModelIndex& );

		QWidget* createEditor( QWidget*, const QStyleOptionViewItem&, const QModelIndex& ) const;
		void setEditorData( QWidget*, const QModelIndex& ) const;
		void setModelData( QWidget*, QAbstractItemModel*, const QModelIndex& ) const;

		QSize sizeHint( const QStyleOptionViewItem&, const QModelIndex& ) const;

	protected:
		void initStyleOption(QStyleOptionViewItem *option, const QModelIndex &index) const;

	private:
		QStyleOptionButton initStyleOptionButton(const QStyleOptionViewItem& option, const QModelIndex &index) const;
		QStyleOptionToolButton initStyleOptionToolButton(const QStyleOptionViewItem& option, const QModelIndex &index) const;

		mutable QSize spinboxsizebuffer;
};

#endif // QTREEITEMMODELDELEGATE_H

