/*
    Copyright 2010 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.
*/

#include <QtGui/QtGui>

#include <qtreeitemmodel.h>
#include <qtreeitemmodeldelegate.h>
#include <tiparameter.h>
#include <tienum.h>
#include <tiaction.h>

using namespace NSCore;

int main(int argc, char** argv)
{
    QApplication app(argc, argv);

    QTreeItemModel* model = new QTreeItemModel( &app );

    QTreeView* view = new QTreeView( 0 );
    view->setModel(model);
    view->setItemDelegate(new QTreeItemModelDelegate(view));

    QTreeItem* parameter = new TiParameter("TiParameter", QVariant::Invalid, model->rootItem());
    new TiParameter("bla", "blub", parameter);
    new TiParameter("integer", 10, parameter);
    new TiParameter("double", 3.14162, parameter);
    new TiParameter("boolean", true, parameter);
    new TiParameter("url", QVariant::Url, parameter);

    new TiEnum("enum", QStringList() << "first" << "second" << "third", 0, model->rootItem());

    new TiAction("action", model->rootItem());


    view->show();

    int ret = app.exec();

    delete view;

    return ret;
}

// vim: et sw=4 ts=4
