/*
    Copyright 2010 EPOS-Project
            (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
            Matthias Nagl <mnagl@uni-goettingen.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.

*/

#include "qurlwidget.h"
#include "qurlwidget.moc"
#include <QFileDialog>
#include <QDir>
#include <QtDebug>

QUrlWidget::QUrlWidget(QWidget *parent)
    : QWidget(parent)
{
    l = new QHBoxLayout(this);
    tb = new QToolButton(this);
    tb->setText("Open File");
    tb->setFocusPolicy(Qt::StrongFocus);
    l->addWidget(tb);
    le = new QLineEdit(this);
    le->setFocusPolicy(Qt::StrongFocus);
    l->addWidget(le);
    l->setContentsMargins(0, 0, 0, 0);
    QObject::connect(tb, SIGNAL(clicked()), SLOT(openFileDialog()));
}

QUrlWidget::~QUrlWidget()
{
}


void QUrlWidget::setText(const QString &text)
{
    le->setText(text);
}

QString QUrlWidget::text() const
{
    return le->text();
}

void QUrlWidget::setIcon(const QIcon &icon)
{
    tb->setIcon(icon);
}

void QUrlWidget::openFileDialog()
{
    qDebug() << "Click!";
    le->setText(QFileDialog::getOpenFileName(this, "Open File", QDir::homePath()));
}
