/*
    Copyright 2010 EPOS-Project
            (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
            Matthias Nagl <mnagl@uni-goettingen.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef QURLWIDGET_H
#define QURLWIDGET_H

#include <QWidget>
#include <QHBoxLayout>
#include <QToolButton>
#include <QLineEdit>

class QUrlWidget : public QWidget
{
    Q_OBJECT
    public:
	QUrlWidget(QWidget *parent);
	~QUrlWidget();
	void setText(const QString &text);
	void setIcon(const QIcon &icon);
	QString text() const;

    public slots:
	void openFileDialog();

    private:
	QHBoxLayout *l;
	QToolButton *tb;
	QLineEdit *le;
};

#endif // QURLWIDGET_H
