/*
    Copyright 2005-2009 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 3 of the License.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; see the files lgpl-3.0.txt and
    gpl-3.0.txt. If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef RESULTVIEWER_P_H
#define RESULTVIEWER_P_H

#include <QtCore/QDebug>

#include <QtCore/QObject>
#include <QtGui/QTableWidgetItem>

#include <cmath>

class ResultWidget
{
	public:
		ResultWidget( QString name, QTableWidget* p ) : min( INFINITY ), max( -INFINITY ), avg( 0 ) {
			//qDebug() << "ResultWidget::ResultWidget(" << name << "," << p << ")";
			int row = p->rowCount();
			p->setRowCount( row+1 );
			p->setItem( row, 0, new QTableWidgetItem( name ) );
			for ( int i=1; i<5; i++ ) {
				QTableWidgetItem* tmp = new QTableWidgetItem( "" );
				items.append( tmp );
				p->setItem( row, i, tmp );
			}
		}
		~ResultWidget() {
		}

		double min, max, avg;
		QList<QTableWidgetItem*> items;
		void addValue( double n ) {
			//qDebug() << "ResultWidget::addValue(" << n << ")";
			if ( n < min ) {
				min = n;
				items[0]->setText( QString::number( min ) );
			}
			if ( n > max ) {
				max = n;
				items[3]->setText( QString::number( max ) );
			}
			avg = (  avg + n ) / 2.0;
			items[1]->setText( QString::number( n ) );
			items[2]->setText( QString::number( avg ) );
		}

};

#endif // RESULTVIEWER_P_H
