/*
    Copyright 2009-2009 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file gpl-3.0.txt. If not, see
    <http://www.gnu.org/licenses/>.
*/

#include "simpleserver.h"
#include "simpleserver.moc"

#include <QtCore/QDebug>
#include <QtGui/QApplication>
#include <QtGui/QPushButton>

#include <netserver.h>
#include <tiparameter.h>

using namespace NSNetwork;

int main( int argc, char** argv )
{
	qDebug() << "Simple server is starting.";

	QApplication app( argc, argv );
	QPushButton* btn = new QPushButton( "Quit" );
	QObject::connect( btn, SIGNAL( clicked() ), btn, SLOT( close() ) );
	btn->show();

	NSCore::QTreeItem* tree = new NSCore::TiParameter( "tree", QVariant::Invalid, 0 );
	new NSCore::TiParameter( "integer", 42, tree );

	NetServer* server = new NetServer( tree, &app );

	int ret = app.exec();

	delete server;

	qDebug() << "Finished.";
	return ret;
}
