
#ifndef TESTNETPROTOCOL_H
#define TESTNETPROTOCOL_H

#include <netprotocol.h>
#include <QtCore>

class TestNetProtocol: public NSNetwork::AbstractNetProtocol
{
    Q_OBJECT
    public:
        TestNetProtocol( QIODevice* dev, QObject* p=0 ) : AbstractNetProtocol( dev, p ), var2( 4711 ) {
            connect( this, SIGNAL( getSpectrum( QString, QByteArray& ) ), this, SLOT( setSpectrum( QString, QByteArray& ) ) );
        }

        int var2;

        QString myxml;

    public slots:
        void setSpectrum( QString name, QByteArray& data ) {
            if ( name=="Heights" ) {
                data = "; Test-Heights\n-1 0\n-0.5 10\n0 20\n";
            }
        }
    protected:
        QStringList getvariables() {
            return QStringList() << "variable1" << "path to/variable 2";
        }
        QString gettype( const QString& name ) {
            if ( name == "variable1" ) return "double";
            if ( name == "path to/variable 2" ) return "int";
            return "invalid";
        }
        QString getvariable( const QString& name ) {
            if ( name == "variable1" ) return "0.0815";
            if ( name == "path to/variable 2" ) return QString::number( var2 );
            return "";
        }
        void setvariable( const QString& name, const QString& value ) {
            //qDebug() << "MyProtocol::setvariable(" << name << "," << value << ")";
            if ( name == "path to/variable 2" ) var2 = value.toInt();
        }

        QString getxml() { return myxml; }
        void setxml(QString xml) { myxml = xml; }

};

#endif
