/*
    Copyright 2009 EPOS-Project
                        (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
                        Arnold Krille <arnold@arnoldarts.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file gpl-3.0.txt. If not, see
    <http://www.gnu.org/licenses/>.
*/

#include "qvxi_test.h"
#include "qvxi_test.moc"

int main( int argc, char** argv )
{
	QApplication app( argc, argv );

	QVxiTest w( 0 );
	w.show();

	return app.exec();

#if 0
	QVxi11* vxi = new QVxi11( &app );

	vxi->connectToHost( QHostAddress( "192.168.25.120" ) );

	QStringList commands;
	commands << "*IDN?";
	//commands << "SENSE:INPUT1:STATE?" << "SENSE:INPUT2:STATE?" << "SENSE:INPUT3:STATE?" << "SENSE:INPUT4:STATE?";
	//commands << "sense:voltage1:protection?" << "sense:voltage3:protection?";

	commands << "status:operation:event?";

	//commands << "sense:sweep:segment:mode?" << "sense:sweep:segment:count?" << "sense:sweep:segment:view?";
	//commands << "sense:sweep:segment:view 1" << "sense:sweep:segment:view?";
	commands << "sense:sweep:points?";

	//commands << "trace:automatic:synchronize?" << "trace:automatic:zoom?";
	commands << /*"format:data?" <<*/ "format:data int,8;data?";

	//commands << "arm?" << "arm:source?" << "arm 1;:arm?" << "system:error:all?";
	//commands << "initiate?" << "initiate:continuous?" << "init;:system:error:all?";
	//commands << "*opc?" << "*TRG" << "*WAI" << "*OPC?";

	commands << "trace:preamble? inp1" << "system:error:all?";

	commands << "TRACE:DATA? INP1" << "system:error:all?";
	commands << "TRACE? INPUT1" << "system:error:all?";

	//commands << "trace:load:input1? 0,100, 100";

	qDebug() << "Commands to test:" << commands;

	foreach( QString cmd, commands ) {
		QString answer = vxi->sendCmd( cmd );
		//for ( int i=0; i<answer.size(); ++i )
		//	qDebug() << i << QString::number( answer.toAscii().data()[ i ], 16 );
		qDebug() << "| " << cmd << ": _" << answer << "_" << answer.size();
	}

	/*QString waddress = vxi->sendCmd( "trace:load:input1? 0,100, 100" );
	qDebug() << " sizeof:" << sizeof( unsigned long );
	qDebug() << " sizeof:" << sizeof( void* );
	qDebug() << " Start address:" << waddress << " " << waddress.toLongLong() << " " << waddress.toULong();
	//void* buf = waddress.toULong();
	//qDebug() << buf;
	*/

	int ret = 0; //app.exec();

	delete vxi;

	return ret;
#endif
}
