/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */


#include <acqiris_thread.h>
#include <acqiris_thread.moc>

#include <QtCore/QDebug>

AcqirisThread::AcqirisThread( QObject* p ) : QThread( p ), _acqiris( new NSAcqiris::Acqiris( this ) ) {
	qDebug( "AcqirisThread::AcqirisThread( QObject %p )", p );
}
AcqirisThread::~AcqirisThread() {
	qDebug( "AcqirisThread::~AcqirisThread()" );
	quit();
}

void AcqirisThread::run() {
	qDebug( "AcqirisThread::run()" );
	for ( int i=0; i<_acqiris->digitizers(); ++i ) {
		NSAcqiris::Digitizer* digitizer = _acqiris->digitizer( i );
		digitizer->calibrate();
		digitizer->setSamples( 100 );
		digitizer->triggerslope( "Negative" );
		digitizer->triggerlevel( -10 );
		digitizer->delaytime( -10E-9 );
		for ( int j=0; j<digitizer->channels() && j<1; ++j ) {
			//qDebug( "Channel %i/%i", i, j );
			digitizer->channel( j )->fullscale( "1V" );
			digitizer->channel( j )->enable( true );
			connect( _acqiris->digitizer( i )->channel( j ), SIGNAL( gotData( ::Acqiris::ChannelData ) ),
			         this, SLOT( dataFromAcqiris( Acqiris::ChannelData ) ) );
		}
		//_acqiris->digitizer( i )->startAcqisition();
	}
	exec();
	for ( int i=0; i<_acqiris->digitizers(); ++i )
		_acqiris->digitizer( i )->stopAcqisition();
	qDebug( "AcqirisThread::run() finished." );
}

void AcqirisThread::dataFromAcqiris( NSAcqiris::ChannelData data ) {
	//qDebug( "AcqirisThread::dataFromAcqiris( NSAcqiris::ChannelData data )" );
	emit gotData( data );
	//emit gotData( QVariant( data ) );
}

