/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */


#include "filter.h"
#include "filter.moc"

Filter::Filter( QObject* p ) : QObject( p ), _threshold( 0 ) {
}
Filter::~Filter() {
}

bool Filter::filter( const NSAcqiris::ChannelData data ) {
	double min = 0;
	for ( int i=0; i<data.size(); ++i ) {
		if ( data[ i ] < min ) min = data[ i ];
	}
	//qDebug( "Filter::filter() min = %e", min );
	if ( min < _threshold )
		return true;

	return false;
}

QVariant Filter::parameter( QString name ) const {
	if ( name == "threshold" )
		return _threshold;
	return QVariant();
}

void Filter::setParameter( QString name, QVariant value ) {
	if ( name == "threshold" )
		_threshold = value.toDouble();
}

QVariant Filter::getConfig() {
	QMap<QString,QVariant> ret;
	ret[ "Ident" ] = QString::number( long( this ) );
	foreach( QString param, parameters() ) {
		ret[ param ] = parameter( param );
	}
	return ret;
}

