/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */

#ifndef FILTER_H
#define FILTER_H

#include <QtCore/QObject>

#include <acqiris_datatypes.h>

class Filter : public QObject
{
	Q_OBJECT
	public:
		Filter( QObject* );
		~Filter();

		// checks the data according to its own parameters,
		// returns true if the data is okay'ed, else false
		bool filter( const NSAcqiris::ChannelData );

		QString type() const { return "Minimumthreshold"; }

		QStringList parameters() const { return QStringList() << "threshold"; }
		QVariant parameter( QString ) const;

		QVariant getConfig();
	public slots:
		void setParameter( QString, QVariant );
	private:
		double _threshold;
};

#endif // FILTER_H

