/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */


#include "net_thread.h"
#include "net_thread.moc"

#include <QtCore/QDebug>

NetThread::NetThread( QObject* p ) : QThread( p ), _client( new EPOClient( this ) ) {
	qDebug( "NetThread::NetThread( QObject* %p )", p );
}
NetThread::~NetThread() {
	qDebug( "NetThread::~NetThread()" );
}

void NetThread::run() {
	qDebug( "NetThread::run()" );

	exec();

	qDebug( "NetThread::run() finished." );
}

void NetThread::sendData( NSAcqiris::ChannelData data ) {
	//qDebug( "NetThread::sendData( NSAcqiris::ChannelData data )" );
	if ( _client )
		_client->sendData( "/data", QVariant( data ) );
}
void NetThread::sendData( QString path, QVariant data ) {
	if ( _client )
		_client->sendData( path, data );
}

