/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */

#ifndef NET_THREAD_H
#define NET_THREAD_H

#include <QtCore/QThread>

#include <net_client.h>

#include <acqiris_datatypes.h>

class NetThread : public QThread
{
	Q_OBJECT
	public:
		NetThread( QObject* =0 );
		~NetThread();

		EPOClient* client() { return _client; }
		EPOConnection_Path* path( QString n ) { if ( _client ) return _client->path( n ); return 0; }

		void run();

	public slots:
		void sendData( NSAcqiris::ChannelData );
		void sendData( QString, QVariant );

	private:
		EPOClient *_client;
};

#endif // NET_THREAD_H

