/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */


#include "worker_thread.h"
#include "worker_thread.moc"

#include "filter.h"

WorkerThread::WorkerThread( QObject* p ) : QThread( p ) {
}
WorkerThread::~WorkerThread() {
}

void WorkerThread::getData( NSAcqiris::ChannelData data ) {

	bool allow = true;
	foreach( Filter* filter, _filters ) {
		allow = filter->filter( data );
	}

	if ( allow )
		emit sendMessage( "/data", QVariant( data ) );
}

void WorkerThread::sendStatus() {
	qDebug( "WorkerThread::sendStatus()" );
	QList<QVariant> list;
	foreach( Filter*filter, _filters )
		list.push_back( filter->getConfig() );
	emit sendMessage( "/filter/status", QVariant( list ) );
}

void WorkerThread::run() {
	qDebug( "WorkerThread::run()" );

	_filters.push_back( new Filter( this ) );

	exec();

	qDebug( "WorkerThread::run()" );
}

