/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */


#include "clientdelegate.h"
#include "clientdelegate.moc"

#include "clientmodel_private.h"

#include <QtCore/QDebug>
#include <QtGui/QPainter>
#include <QtCore/QModelIndex>

using namespace NSClientModel;

ClientDelegate::ClientDelegate( QObject* p ) : QItemDelegate( p ) {
	qDebug( "ClientDelegate::ClientDelegate( QObject* %p )", p );
}
ClientDelegate::~ClientDelegate() {
	qDebug( "ClientDelegate::~ClientDelegate()" );
}

void ClientDelegate::paint( QPainter* painter, const QStyleOptionViewItem& style, const QModelIndex& index ) const {
	//qDebug( "ClientDelegate::paint( ... )" );
	if ( ComputerItem* comp = computerItem( index ) ) {
		qDebug( " comp = %p", comp );
		painter->drawText( style.rect, Qt::AlignCenter, QString( "Test: %1" ).arg( comp->data().toString() ) );
	} else
		QItemDelegate::paint( painter, style, index );
}

QSize ClientDelegate::sizeHint( const QStyleOptionViewItem& style, const QModelIndex& index ) const {
//	qDebug() << "ClientDelegate::sizeHint( style, QModelIndex" << index << " )";
//	if ( ComputerItem* comp = computerItem( index ) ) {
//		qDebug( "\n called sizeHint with ComputerItem as argument!\n" );
//		return QSize( 200, 40 );
//	} else
		return QItemDelegate::sizeHint( style, index );
}

ComputerItem* ClientDelegate::computerItem( const QModelIndex& index ) const {
	TreeItem* item = static_cast<TreeItem*>( index.internalPointer() );
	return dynamic_cast<ComputerItem*>( item );
}

