/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */

#ifndef CLIENTMODEL_H
#define CLIENTMODEL_H

#include <QtCore/QAbstractItemModel>
//#include <QtGui/QStandardItemModel>

class EPOServer;
class EPOServerClient;

namespace NSClientModel {
	class TreeItem;
};

class ClientModel : public QAbstractItemModel
{
	Q_OBJECT
	public:
		ClientModel( QObject* );
		~ClientModel();

		QModelIndex index( int, int, const QModelIndex& =QModelIndex() ) const;
		QModelIndex parent( const QModelIndex& = QModelIndex() ) const;
		int rowCount( const QModelIndex& = QModelIndex() ) const;
		int columnCount( const QModelIndex& = QModelIndex() ) const;
		QVariant data( const QModelIndex&, int ) const;
		bool hasChildren( const QModelIndex& ) const;

	public slots:
		void newClient( EPOServerClient* );
		void removeClient( EPOServerClient* );

	private:
		//QList<EPOServerClient*> _clients;
		//QList<QModelIndex> _indexes;
		NSClientModel::TreeItem* _rootItem;
		NSClientModel::TreeItem* _testItem;
};

#endif // CLIENTMODEL_H

