/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */


#include "clientmodel_private.h"
#include "clientmodel_private.moc"

using namespace NSClientModel;

ComputerItem::ComputerItem( EPOServerClient* client, TreeItem* p ) : TreeItem( "(no name given)", p ), _client( client ) {
	qDebug( "ComputerItem::ComputerItem( EPOServerClient* %p, TreeItem* %p )", client, p );
	_filters = new TreeItem( "Filters", this );
	_modules = new TreeItem( "Calculators", this );
	connect( client->path( "/filter/status" ), SIGNAL( gotMessage( QVariant ) ), this, SLOT( statusModules( QVariant ) ) );
}

void ComputerItem::statusModules( QVariant data ) {
	qDebug() << "ComputerItem::statusModules( QVariant '" << data << "' )";
	_filters->removeAllChilds();

	QList<QVariant> list = data.toList();
	foreach( QVariant item, list ) {
		QMap<QString,QVariant> params = item.toMap();
		new FilterItem( params, _filters );
	}
}

FilterItem::FilterItem( QMap<QString,QVariant> params, TreeItem* p ) : TreeItem( "(Filter)", p ), _params( params ) {
	_data = QString( "Filter %1" ).arg( _params[ "Ident" ].toString() );
}

QVariant FilterItem::value( QString n ) const {
	return _params[ n ];
}

