/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */


#include "clientview.h"
#include "clientview.moc"

#include <QtCore/QDebug>
#include <QtGui/QVBoxLayout>
#include "clientmodel_private.h"
#include "treeitemwidgetui.h"
#include "treeitemwidget_filter.h"

using namespace NSClientModel;

ClientView::ClientView( QWidget* p ) : QAbstractItemView( p ) {
	qDebug() << "ClientView::ClientView( QWidget* " << p << " )";
	layout = new QVBoxLayout( viewport() );
	viewport()->setLayout( layout );
}
ClientView::~ClientView() {
	qDebug() << "ClientView::~ClientView()";
}

void ClientView::setSelection( const QRect& rect, QItemSelectionModel::SelectionFlags flags ) {
	qDebug() << "ClientView::setSelection( const QRect " << rect
	         << ", QItemSelectionModel::SelectionFlags " << flags << " )";
}

void ClientView::setSelectionModel( QItemSelectionModel* selmodel ) {
	connect( selmodel, SIGNAL( currentChanged( const QModelIndex&, const QModelIndex& ) ),
	         this, SLOT( setSelection( const QModelIndex&, const QModelIndex& ) ) );
	QAbstractItemView::setSelectionModel( selmodel );
}

void ClientView::setSelection( const QModelIndex& current, const QModelIndex& last ) {
	static QWidget* itemwidget = new QWidget( viewport() );
	qDebug() << "ClientView::setSelection( const QModelIndex& " << current
	         << ", const QModelIndex& " << last << " )";
	TreeItem* item = static_cast<TreeItem*>( current.internalPointer() );
	qDebug() << "internalPointer = " << current.internalPointer()
	         << " item = " << item
	         << " item.data() = " << item->data().toString();
//	ComputerItem* comp = dynamic_cast<ComputerItem*>( item );
//	if ( comp )
//		qDebug() << "\nFound a ComputerItem!!!" << endl;
	FilterItem* filter = dynamic_cast<FilterItem*>( item );

	/// TODO: Next widget based on type of item...
	if ( itemwidget != 0 )
		delete itemwidget;
	if ( filter ) {
		itemwidget = new TreeItemWidget_Filter( filter, viewport() );
	} else {
		itemwidget = new QWidget( viewport() );
		Ui::TreeItemWidget* treeitemwidget = new Ui::TreeItemWidget;
		treeitemwidget->setupUi( itemwidget );
		treeitemwidget->label->setText( item->data().toString() );
	}
	layout->addWidget( itemwidget );
	itemwidget->show();
}

