/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */

#ifndef CLIENTVIEW_H
#define CLIENTVIEW_H

#include <QtGui/QAbstractItemView>

class ClientView : public QAbstractItemView
{
	Q_OBJECT
	public:
		ClientView( QWidget* );
		~ClientView();

		QModelIndex indexAt( const QPoint& ) const { return QModelIndex(); }
		void scrollTo( const QModelIndex&, ScrollHint = EnsureVisible ) { }
		QRect visualRect( const QModelIndex& ) const { return viewport()->rect(); }

		void setSelectionModel( QItemSelectionModel* );
	protected:
		QModelIndex moveCursor( CursorAction, Qt::KeyboardModifiers ) { return QModelIndex(); }
		void setSelection( const QRect&, QItemSelectionModel::SelectionFlags );
		QRegion visualRegionForSelection( const QItemSelection& ) const { return QRegion(); }
		bool isIndexHidden( const QModelIndex& ) const { return false; }

		int horizontalOffset() const { return 0; }
		int verticalOffset() const { return 0; }
	private slots:
		void setSelection( const QModelIndex&, const QModelIndex& );
	private:
		QLayout *layout;
};

#endif // CLIENTVIEW_H

