/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */

#ifndef MAINWIDGET_H
#define MAINWIDGET_H

//#include <Qt/q3hbox.h>
#include <QtCore/QList>
#include <QtGui/QFrame>
#include <QtGui/QMainWindow>

class OsciWidget;
class QSplitter;
namespace Ui {
	class OsciTabs;
	class AcqirisTabsV2;
	class VerticalParameters;
}

namespace NSAcqiris {
	class Acqiris;
};

class EPOServerClient;

class Mainwidget : public QMainWindow {
Q_OBJECT
public:
	Mainwidget( EPOServerClient*, QWidget* =0 );
	~Mainwidget();
protected:
	void closeEvent( QCloseEvent* );
private slots:
	void saveSettings();
	void loadSettings();
//private:
public:
	QSplitter *_splitter;
	NSAcqiris::Acqiris* _acqiris;
	Ui::AcqirisTabsV2 *_acqirisbox2;
	QWidget* _acqirisbox2_widget;
	OsciWidget* _osciwidget;
	Ui::OsciTabs *_oscitabs;
	QWidget* _oscitabs_widget;
	QList<Ui::VerticalParameters*> _verticalparameters;
	EPOServerClient* _socket;
};

#endif // MAINWIDGET_H

