/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */


#include <QtCore/QDebug>
#include <QtCore/QCoreApplication>

#include <libdiskio/diskiobuffers.h>
#include <libdiskio/diskiobuffers_bin.h>

using namespace NSDiskIO;

int main( int argc, char** argv )
{

	QCoreApplication app( argc, argv );

	foreach( QString arg, app.arguments() )
		qDebug() << arg;

	if ( app.arguments().size() > 1 ) {
		QString filename = app.arguments().at( 1 );

		EPOSReader* reader = new EPOSReader( &app );
		EPOSBinWriter* writer = new EPOSBinWriter( &app );

		reader->setFile( filename );
		writer->setFile( filename.replace( ".eposfile", ".eposbinfile" ) );

		reader->registerConsumer( writer );

		reader->readAllDataSets();

		return 0;
	}
	else
	{
		qWarning() << "You need to provide at least the name of the file to convert as an argument!";
		return 1;
	}

	return 0; //app.exec();
}

