
#include <iostream>
#include <cstdlib>
#include <cmath>

#include <QtCore/QVector>
#include <QtCore/QMap>
#include <QtCore/QFile>
#include <QtCore/QTextStream>

using namespace std;

int main()
{
	cout << "Starting some tests regarding noise..." << endl << endl;

	srand( time( 0 ) );

	QVector<double> numbers;

	int count = 1000000;
	cout << "Generating " << count << " random-numbers in the range [-1:1]" << endl << endl;
	for ( int i=0; i<count; ++i ) {
		numbers.push_back( ( rand()*2.0/RAND_MAX - 1 ) );
	}


	cout << "Writing count-statistics to random.stat.csv" << endl << endl;
	QMap<double,int> stat;
	foreach( double d, numbers ) {
		stat[ d-( fmod( d, 0.01 ) ) ] += 1;
	}
	QFile file( "random.stat.csv" );
	if ( file.open( QIODevice::WriteOnly ) ) {
		QTextStream stream( &file );

		foreach( double d, stat.keys() ) {
			if ( d == 0 )
				stat[ d ] /= 2;
			stream << d << " " << stat[ d ] << endl;
		}

		file.close();
	}


	cout << "Calculating mean value" << endl;
	double mean = 0;
	foreach( double d, numbers )
		mean += d;
	mean /= numbers.size();
	cout << " Mean is " << mean << endl << endl;


	cout << "Calculating deviation" << endl;
	double dev = 0;
	foreach( double d, numbers )
		dev += powf( d - mean, 2 );
	dev = sqrt( dev/( count-1.0 ) );
	cout << " Deviation is " << dev << endl << endl;


	cout << "Finished." << endl;
	return 0;
}

