
#include <QCoreApplication>
#include <QDebug>

#include <cstdlib>

#include "myevent.h"
#include "mythread.h"

using namespace std;

int main( int argc, char** argv )
{
	QCoreApplication qapp( argc, argv );

	int events = 200000;

	MyEventSender* sender = new MyEventSender( events, &qapp );

	MyThread* t1 = new MyThread();
	t1->start();
	MyThread* t2 = new MyThread();
	t2->start();
	MyThread* t3 = new MyThread();
	t3->start();
	MyThread* t4 = new MyThread();
	t4->start();
	while ( ! t1->object && ! t2->object && ! t3->object && ! t4->object )
		usleep( 10 );

	MyEventChain* c1 = t1->object;//new MyEventChain( &qapp );
	sender->setNextInChain( c1 );
	MyEventChain* c2 = t2->object;//new MyEventChain( &qapp );
	c1->setNextInChain( c2 );
	MyEventChain* c3 = t3->object;//new MyEventChain( &qapp );
	c2->setNextInChain( c3 );
	MyEventChain* c4 = t4->object;//new MyEventChain( &qapp );
	c3->setNextInChain( c4 );

	time_t time1 = time( 0 );

	int ret = qapp.exec();

	time_t time2 = time( 0 );
	qDebug() << " * It took" << time2 - time1 << "seconds to process the events. That is" << events / ( time2 - time1 ) << "events per second";

	t1->quit();
	t1->wait();
	delete t1;
	t2->quit();
	t2->wait();
	delete t2;
	t3->quit();
	t3->wait();
	delete t3;
	t4->quit();
	t4->wait();
	delete t4;

	return ret;
}

