
#include "myevent.h"
#include "myevent.moc"

#include <QDebug>
#include <QTimer>
#include <QEvent>
#include <QCoreApplication>

const QEvent::Type MyEventNumber = ( QEvent::Type )1296;

class MyEvent : public QEvent
{
	public:
		MyEvent( int n ) : QEvent( MyEventNumber ), number( n ) {
			//qDebug() << "MyEvent::MyEvent(" << n << ")";
		}

		int number;
};

MyEventChain::MyEventChain( QObject* p ) : QObject( p ), _nextInChain( 0 ) {
	qDebug() << "MyEventChain::MyEventChain(" << p << ")";
}

void MyEventChain::setNextInChain( MyEventChain* n ) {
	qDebug() << "MyEventChain << setNextInChain(" << n << ")";
	_nextInChain = n;
}

bool MyEventChain::event( QEvent* ev ) {
	//qDebug() << "MyEventChain::event(" << ev << ")";
	if ( ev->type() == MyEventNumber && _nextInChain ) {
		MyEvent* myev = dynamic_cast<MyEvent*>( ev );
		if ( myev && _nextInChain ) {
			QCoreApplication::postEvent( _nextInChain, new MyEvent( myev->number ) );
			return true;
		}
	}
	return QObject::event( ev );
}

MyEventSender::MyEventSender( int n, QObject* p ) : MyEventChain( p ), i( n ) {
	qDebug() << "MyEventSender::MyEventSender(" << n << "," << p << ")";
	QTimer::singleShot( 5, this, SLOT( sendSignals() ) );
}
void MyEventSender::sendSignals() {
	if ( i % 10000 == 0 )
		qDebug() << "MyEventSender::sendSignals() i =" << i;
	MyEvent* ev = new MyEvent( i );
	QCoreApplication::postEvent( _nextInChain, ev );
	i--;
	if ( i > 0 )
		QTimer::singleShot( 0, this, SLOT( sendSignals() ) );
	else {
		qDebug() << "All events sent.";
		QCoreApplication::exit();
	}
}

