/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */


#include <QtGui/QApplication>
#include <QtGui/QPushButton>
#include <QtScript/QScriptEngine>
#include <QtCore/QDebug>

int main( int argc, char** argv ) {

	QApplication app( argc, argv );
	app.setObjectName( "app" );

	QPushButton *btn = new QPushButton( "Script" );
	btn->setObjectName( "bla" );

	QScriptEngine *engine = new QScriptEngine( btn );

	QScriptValue sbtn = engine->newQObject( btn );
	engine->globalObject().setProperty( "btn", sbtn );
	engine->globalObject().setProperty( "app", engine->newQObject( &app ) );

	QString script = "\
function handler()\n \
{\n\
	btn.text = \"Quit!\";\n\
	btn[ \"clicked()\"].connect( app, \"quit()\" );\n\
}\n\
print( btn );\n\
btn[ \"clicked()\" ].connect( handler );\n\
";

	qDebug() << "Script:\n" << script;
	qDebug() << " Can evaluate the script:" << engine->canEvaluate( script );

	engine->evaluate( script, "testing" );

	qDebug() << " Has uncaught exceptions:" << engine->hasUncaughtException();
	if ( engine->hasUncaughtException() ) {
		qDebug() << engine->uncaughtExceptionBacktrace().join( "\n" );
	}

	btn->show();

	return app.exec();
}

