/*
 * Copyright 2005-2008 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */


#include <QtGui/QtGui>

#include "main.h"
#include "main.moc"

TreeTest::TreeTest( QWidget* p ) : tv( new QTreeView( p ) ), model( new QStandardItemModel() ) {
	addLines();
	tv->setModel( model );
	tv->show();
}

void TreeTest::addLines() {
	QModelIndex parent = tv->currentIndex();
	model->insertColumn( 0, parent );
	//tv->expand( parent );
	for ( int i = 0; i < 4; ++i ) {
		model->insertRows( 0, 1, parent );
		QModelIndex index = model->index( 0, 0, parent );
		model->setData( index, i );
		if ( i==3 )
			parent = index;
		qDebug() << parent;
	}
}

void TreeTest::rmLines() {
	QModelIndex parent = tv->currentIndex();
	qDebug() << "parent =" << parent;
	QModelIndex realparent = parent.parent();
	qDebug() << "parent.parent() =" << parent.parent();
	qDebug() << "removeRows returns" << model->removeRows( 0, 1, realparent );
	qDebug() << " model->rowCount(realparent) " << model->rowCount( realparent );
	if ( model->rowCount( realparent ) == 0 )
		parent = realparent;
}

int main( int argc, char **argv )
{
	QApplication a( argc, argv );
	QSplitter* splitter = new QSplitter();
	TreeTest* tree = new TreeTest( splitter );

	QPushButton* btnadd = new QPushButton( "Add Lines", splitter );
	QObject::connect( btnadd, SIGNAL( clicked() ), tree, SLOT( addLines() ) );
	QPushButton* btnrm = new QPushButton( "Remove Lines", splitter );
	QObject::connect( btnrm, SIGNAL( clicked() ), tree, SLOT( rmLines() ) );

	splitter->show();

	return a.exec();
}
