/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */


#include <QtGui/QApplication>

#include <QtGui/QStandardItemModel>
#include <QtGui/QTableView>
#include <QtGui/QSplitter>
#include <QtCore/QFile>
#include <QtCore/QTextStream>

#include <math.h>

#include "chartview.h"
#include "reclassifymodel.h"
#include "reclassifyview.h"

int main( int argc, char* argv[] )
{
	QApplication* app = new QApplication( argc, argv );

	//QAbstractItemModel *model = new QStandardItemModel( 0, 2, app );
	ReclassifyModel *model = new ReclassifyModel( app );
	model->setHeaderData( 0, Qt::Horizontal, "Time" );
	model->setHeaderData( 1, Qt::Horizontal, "Quantity" );

	QSplitter *vsplitter = new QSplitter( Qt::Vertical );
	QSplitter *hsplitter = new QSplitter( vsplitter );

	QTableView *table = new QTableView( hsplitter );
	table->setModel( model );

	ChartView *chart = new ChartView( hsplitter );
	chart->setModel( model );

	ReclassifyView *reclassify = new ReclassifyView( vsplitter );
	reclassify->setModel( model );

	vsplitter->setStretchFactor( 0, 100 );
	vsplitter->setStretchFactor( 1, 1 );

	hsplitter->setStretchFactor( 0, 50 );
	hsplitter->setStretchFactor( 1, 100 );

	vsplitter->show();

	return app->exec();
}

