/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */

#ifndef RECLASSIFYMODEL_H
#define RECLASSIFYMODEL_H

#include <QtCore/QAbstractTableModel>

class ReclassifyModel : public QAbstractTableModel
{
	Q_OBJECT
	public:
		ReclassifyModel( QObject* );
		~ReclassifyModel();

		int classes();

		int rowCount( const QModelIndex& ) const;
		int columnCount( const QModelIndex& ) const;

		QVariant data( const QModelIndex&, int ) const;

		Qt::ItemFlags flags( const QModelIndex& ) const { return Qt::ItemIsSelectable|Qt::ItemIsEnabled; }

	public slots:
		void setClasses( int );
		void loadFile( QString );
		void clear();

		void saveFile( QString );

	private:
		void reclassify( int );
		typedef QMap< double,double > TableType;
		TableType _table;
		TableType _classtable;
};

#endif // RECLASSIFYMODEL_H

