/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */


#include "reclassifyview.h"
#include "reclassifyview.moc"
#include "reclassifywidget.h"

#include "reclassifymodel.h"
#include <QtGui/QFileDialog>

ReclassifyView::ReclassifyView( QWidget* p ) : QAbstractItemView( p ), _widget( new Ui::ReclassifyWidget() ), _model( 0 ) {
	setFrameStyle( QFrame::NoFrame );
	_widget->setupUi( viewport() );
	setFixedHeight( viewport()->minimumHeight() );
	connect( _widget->btnLoad, SIGNAL( clicked() ), this, SLOT( loadFile() ) );
	connect( _widget->btnSave, SIGNAL( clicked() ), this, SLOT( saveFile() ) );
}
ReclassifyView::~ReclassifyView() {
}

void ReclassifyView::setModel( ReclassifyModel* model ) {
	QAbstractItemView::setModel( model );
	_model = model;
	_widget->spinboxClassesCount->setValue( _model->classes() );
	connect( _widget->spinboxClassesCount, SLOT( valueChanged( int ) ), _model, SLOT( setClasses( int ) ) );
}

void ReclassifyView::loadFile() {
	QString file = QFileDialog::getOpenFileName( this, "Data to load...", "", "*.csv" );
	if ( !file.isEmpty() )
		_model->loadFile( file );
}

void ReclassifyView::saveFile() {
	QString file = QFileDialog::getSaveFileName( this, "Save Spectrum to...", "", "*.dat\n*.csv\n*.*" );
	if ( !file.isEmpty() )
		_model->saveFile( file );
}

