/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */

#ifndef RECLASSIFYVIEW_H
#define RECLASSIFYVIEW_H

#include <QtGui/QAbstractItemView>

class ReclassifyModel;

namespace Ui {
	class ReclassifyWidget;
};

class ReclassifyView : public QAbstractItemView
{
	Q_OBJECT
	public:
		ReclassifyView( QWidget* =0 );
		~ReclassifyView();

		QRect visualRect( const QModelIndex& ) const { return QRect(); }
		void scrollTo( const QModelIndex&, ScrollHint =EnsureVisible ) { }
		QModelIndex indexAt( const QPoint& ) const { return QModelIndex(); }

		void setModel( ReclassifyModel* );

	public slots:
		void loadFile();
		void saveFile();

	protected:
		QModelIndex moveCursor( QAbstractItemView::CursorAction, Qt::KeyboardModifiers ) { return QModelIndex(); }

		int horizontalOffset() const { return 0; }
		int verticalOffset() const { return 0; }

		bool isIndexHidden( const QModelIndex& ) const { return false; }

		void setSelection( const QRect&, QItemSelectionModel::SelectionFlags ) { }

		QRegion visualRegionForSelection( const QItemSelection& ) const { return QRegion(); }
	private:
		Ui::ReclassifyWidget *_widget;
		ReclassifyModel* _model;
};

#endif // RECLASSIFYVIEW_H

