
#include <QtGui/QtGui>
#include "main.h"
#include "main.moc"

SCPI::SCPI( QObject* p ) : QObject( p ) {
	qDebug() << "SCPI::SCPI(" << p << ")";
	socket = new QTcpSocket( this );
	connect( socket, SIGNAL( readyRead() ), this, SLOT( read() ) );
	connect( socket, SIGNAL( connected() ), this, SLOT( connected() ) );
	connect( socket, SIGNAL( error( QAbstractSocket::SocketError ) ), this, SLOT( error( QAbstractSocket::SocketError ) ) );
	socket->connectToHost( "192.168.25.120", 3030 );
}
void SCPI::read() {
	qDebug() << "SCPI::read()";
}
void SCPI::connected() {
	qDebug() << "SCPI::connected()";
	socket->write( "*IDN?\n" );
	socket->flush();
}
void SCPI::error( QAbstractSocket::SocketError e ) {
	qDebug() << "SCPI::error(" << e << ")";
}

int main( int argc, char** argv )
{
	QApplication app( argc, argv );

	SCPI scpi( 0 );

	QPushButton btn( "Quit" );
	QObject::connect( &btn, SIGNAL( clicked() ), &btn, SLOT( close() ) );
	btn.show();

	return app.exec();
}
