/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */


#include "ortek.h"

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>

/*############################################################################*/

spec_chn _load_chn_in ( const char* name )
{
	spec_chn chn_in;
	FILE *fp;
	int i;

	strcpy ( chn_in.name , name );
	fp = fopen( chn_in.name , "rb" );
	if ( fp == NULL )
	{
		printf ( "error : open file : %s\n" , chn_in.name );
		exit( 1 );
	}

	/* read first info block */
	fseek ( fp, 0 , SEEK_SET );
	fread ( &chn_in.res_1 , 2 , 1 , fp );

	fseek ( fp, 2 , SEEK_SET );
	fread ( &chn_in.res_2 , 2 , 1 , fp );

	fseek ( fp, 4 , SEEK_SET );
	fread ( &chn_in.res_3 , 2 , 1 , fp );

	fseek ( fp, 6 , SEEK_SET );
	fread ( &chn_in.start_time_sec , 2 , 1 , fp );

	fseek ( fp, 8 , SEEK_SET );
	fread ( &chn_in.real_time , 4 , 1 , fp );

	fseek ( fp, 12 , SEEK_SET );
	fread ( &chn_in.live_time , 4 , 1 , fp );

	fseek ( fp, 16 , SEEK_SET );
	fread ( &chn_in.start_date , 7 , 1 , fp );

	fseek ( fp, 24 , SEEK_SET );
	fread ( &chn_in.start_time , 4 , 1 , fp );

	fseek ( fp, 28 , SEEK_SET );
	fread ( &chn_in.channel_offset , 2 , 1 , fp );

	fseek ( fp, 30 , SEEK_SET );
	fread ( &chn_in.channel_number , 2 , 1 , fp );

	/* read data block */

	fseek ( fp, 32 , SEEK_SET );
	fread ( &chn_in.data , 4 , chn_in.channel_number , fp );

	/* read last info block */

	fseek ( fp , -512 , SEEK_END );
	fread ( &chn_in.flag ,	   2 , 1 , fp );

	fseek ( fp , -510 , SEEK_END );
	fread ( &chn_in.res_4 ,	   2 , 1 , fp );

	fseek ( fp , -508 , SEEK_END );
	fread ( &chn_in.ecal_offset ,	     4 , 1 , fp );	

	fseek ( fp , -504 , SEEK_END );
	fread ( &chn_in.ecal_gain ,        4 , 1 , fp );	

	fseek ( fp , -500 , SEEK_END );
	fread ( &chn_in.ecal_quad ,		 4 , 1 , fp );	

	fseek ( fp , -496 , SEEK_END );
	fread ( &chn_in.peakshape_offset , 4 , 1 , fp );	

	fseek ( fp , -492 , SEEK_END );
	fread ( &chn_in.peakshape_gain ,	 4 , 1 , fp );	

	fseek ( fp , -488 , SEEK_END );
	fread ( &chn_in.peakshape_quad ,   4 , 1 , fp );	

	fseek ( fp , -484 , SEEK_END );
	fread ( &chn_in.res_6 ,	   228 , 1 , fp );

	fseek ( fp , -256 , SEEK_END );
	fread ( &chn_in.res_7 ,	   1 , 1 , fp );

	fseek ( fp , -255 , SEEK_END );
	fread ( &chn_in.detector ,	    63 , 1 , fp );	

	fseek ( fp , -192 , SEEK_END );
	fread ( &chn_in.res_8 ,	   1 , 1 , fp );

	fseek ( fp , -191 , SEEK_END );
	fread ( &chn_in.sample ,	   63 , 1 , fp );

	fseek ( fp , -128 , SEEK_END );
	fread ( &chn_in.res_9 ,	   128 , 1 , fp );

	printf ( "name                 : %s\n" , chn_in.name );
	printf ( "start time sec       : %2s\n", chn_in.start_time_sec );
	printf ( "real time            : %7d\n", int( chn_in.real_time ) );
	printf ( "live time            : %7d\n", int( chn_in.live_time ) );
	printf ( "start date           : %7s\n", chn_in.start_date );
	printf ( "start time           : %4s\n", chn_in.start_time );
	printf ( "channel offset       : %7d\n", chn_in.channel_offset );
	printf ( "number of channels   : %7d\n", chn_in.channel_number );
	printf ( "old new flag         : %7d\n", chn_in.flag );
	printf ( "detektor             : %30s\n", chn_in.detector );
	printf ( "energycal gains      : %7f\n", chn_in.ecal_gain);
	printf ( "energycal offset     : %7f\n", chn_in.ecal_offset);
	printf ( "energycal quad       : %7f\n", chn_in.ecal_quad);
	printf ( "peakshape offset     : %7f\n", chn_in.peakshape_offset);
	printf ( "peakshape gain       : %7f\n", chn_in.peakshape_gain);
	printf ( "peakshape quad       : %7f\n", chn_in.peakshape_quad);

	for (i =1043 ; i < 1050 ; i += 1 )
  		printf ( "sample data          : %7d - %7d\n", i, int( chn_in.data[i] ) );

	fclose ( fp );

	return chn_in;
}

