/*
 * Copyright 2005-2007 EPOS-project
 *                     (FZ Dresden-Rossendorf & MLU Halle-Wittenberg)
 */


/*############################################################################*/

struct spec_chn
{
	char	name[60];
	short	res_1;
	short	res_2;
	short	res_3;
	char	start_time_sec[2];
	long	real_time;
	long	live_time;
	char	start_date[8];
	char	start_time[4];
	short	channel_offset;
	short	channel_number;
	long 	data[35000]; /*set to max 35 k */
	short	flag;
	short	res_4;
	float	ecal_offset;
	float	ecal_gain;
	float	ecal_quad;
	float	peakshape_offset;
	float	peakshape_gain;
	float	peakshape_quad;
	char	res_6[228];
	char	res_7;
	char	detector[63];
	char	res_8;
	char	sample[63];
	char	res_9[128];

};

/*############################################################################*/
/* ORTEC CHN INTEGER FORMAT for gamma spectra .chn 							  */
/*																			  */
/*  byte data	description 												  */
/* 	 0	2		should be -1, 2 byte integer								  */
/* 	 2	2		mca number or detector number, 2 byte integer				  */
/* 	 4	2		segment number, set to 1 in UMCBI, 2 byte integer 			  */
/*   6	2		ASCII seconds of start 										  */
/*   8	4		real time (inc. of 20 ms) 4 byte integer 					  */
/*  12	4		live time (inc. of 20 ms) 4 byte integer 					  */
/*  16	8		start date as ASCII DDMMMYY or binary zeros if unknown, 	  */
/*				the last 1 indicates 2000++ 								  */
/*  24	4		start time as ASCII HHMM or binary zeros if unknown 		  */
/*  28	2		channel offset, 2 byte integer								  */
/*  30	2		number of channels, 2 byte integer							  */
/*  32  4       ...data as 4 byte integer 									  */ 
/* 										   									  */
/*  0	2		should be -101 for older software - GV V2 or Maestro V3 	  */
/*  2	2		reserved 													  */
/*  4	4		energy calibration zero intercept, 0.0 for uncal, 4 byte float*/
/*  8	4		energy calibration slope, 1.0 for uncal, 4 byte float		  */
/*  12	4		reserved (float or integer ?)								  */
/*  16	4		peak shape calib. zero intercept, 1.0 for uncal, 4 byte float */
/*  20	4		peak shape calib. slope, 0.0 for uncal, 4 byte float		  */
/*  24	232		reserved													  */
/* 256	1		length of detector description								  */
/* 257	63		detector description										  */
/* 320	1		length of sample description 								  */
/* 321	63		sample description											  */
/* 384	128		reserved - total length is 512 byte							  */
/* 										   									  */
/*  0	2		should be -102 for new software - GV V2.2 or Maestro V3.1 	  */
/*  2	2		reserved 													  */
/*  4	4		energy calibration zero intercept, 0.0 for uncal, 4 byte float*/
/*  8	4		energy calibration slope, 1.0 for uncal, 4 byte float		  */
/*  12	4		energy calibration quadratic term, 0.0 for uncal, 4 byte float*/
/*  16	4		peak shape calib. zero intercept, 1.0 for uncal, 4 byte float */
/*  20	4		peak shape calib. slope, 0.0 for uncal, 4 byte float	  	  */
/*  24	4		peak shape calib. quadratic term, 0.0 for uncal, 4 byte float */
/*  28	228		reserved													  */
/* 256	1		length of detector description								  */
/* 257	63		detector description										  */
/* 320	1		length of sample description 								  */
/* 321	63		sample description											  */
/* 384	128		reserved - total length is 512 byte							  */
/*############################################################################*/

spec_chn _load_chn_in ( const char* );

/*############################################################################*/

