
#include <QtGui/QApplication>
#include <QtCore/QDebug>

#include "main.h"
#include "main.moc"

MyObject::MyObject( QObject* p ) : QObject( p ) {
	w = new KTextEditVT( 0 );
	w->setParseAnsiEscapeCodes( true );

	serial = new NSSnap::QSerial( "/dev/ttyS0", this );
	connect( serial, SIGNAL( readyRead() ), this, SLOT( readData() ) );
	qDebug() << serial->open( QIODevice::ReadOnly|QIODevice::WriteOnly );
	serial->write( "\n" );
}

void MyObject::readData() {
	QByteArray tmp = serial->readAll();
	qDebug() << "MyObject::readData() read:" << tmp;
	w->insertVTText( tmp );
}

int main( int argc, char** argv )
{
	qDebug() << "vt100-test starting...";

	QApplication app( argc, argv );

	MyObject* obj = new MyObject( &app );

	//KTextEditVT* w = new KTextEditVT( 0 );
	obj->w->show();

	int ret = app.exec();

	qDebug() << "vt100-test finished.";
	return ret;
}
