
#include "vxi11.h"
#include "vxi11_xdr.c"
#include "vxi11_clnt.c"
//#include "vx11-irqproto.h"

int main( int argc, char** argv )
{
	char* cmd = "sense:roscillator:source?\n"; //"calibration:date?\n";

	CLIENT* VXI11Client;
	if ((VXI11Client = clnt_create("192.168.25.120", DEVICE_CORE, DEVICE_CORE_VERSION, "tcp")) == NULL ) {
		printf("Failed to establish the connection!!!\n");
		return -1;
	}

	Create_LinkParms MyCreate_LinkParms;
	MyCreate_LinkParms.clientId = 0;
	MyCreate_LinkParms.lockDevice = 0;
	MyCreate_LinkParms.lock_timeout = 0;
	MyCreate_LinkParms.device = "inst0";
	Create_LinkResp *MyCreate_LinkResp;
	if ((MyCreate_LinkResp = create_link_1(&MyCreate_LinkParms,VXI11Client)) == NULL) {
		printf("Failed to connect to the device...\n");
		goto END;
	}

	Device_Link MyLink;
	MyLink = MyCreate_LinkResp->lid;

	Device_WriteParms MyDevice_WriteParms;
	MyDevice_WriteParms.lid = MyLink;
	MyDevice_WriteParms.io_timeout = 10000;
	MyDevice_WriteParms.lock_timeout = 10000;
	MyDevice_WriteParms.flags = 0;
	//MyDevice_WriteParms.data.data_val = "*IDN?\n";
	MyDevice_WriteParms.data.data_val = cmd;
	MyDevice_WriteParms.data.data_len = strlen( cmd );
	Device_WriteResp *MyDevice_WriteResp;
	if ((MyDevice_WriteResp=device_write_1(&MyDevice_WriteParms,VXI11Client)) == NULL) {
		printf("Failed to write to the device!\n");
	}

	Device_ReadParms MyDevice_ReadParms;
	MyDevice_ReadParms.lid = MyLink;
	MyDevice_ReadParms.requestSize = 200000;
	MyDevice_ReadParms.io_timeout = 10000;
	MyDevice_ReadParms.lock_timeout = 10000;
	MyDevice_ReadParms.flags = 0;
	MyDevice_ReadParms.termChar = '\n';
	Device_ReadResp *MyDevice_ReadResp;
	if ((MyDevice_ReadResp=device_read_1(&MyDevice_ReadParms,VXI11Client)) == NULL) {
		printf("Failed to read back...\n");
	}
	printf("%s\n", MyDevice_ReadResp->data.data_val );
	char DataRead[200000];
	strncpy(DataRead, MyDevice_ReadResp->data.data_val, MyDevice_ReadResp->data.data_len);
	DataRead[MyDevice_ReadResp->data.data_len] = 0;
	printf(" Instrument ID string: %s\n", DataRead);

	printf(" Running fine :-)\n");

END:
	clnt_destroy(VXI11Client);
	return 0;
}
